(function(global, $) {
	mui.init({swipeBack:false});
	
    var vm = new Vue({
        el: "#app",
        data: {
            tab: 0,
            itemTab: 0
        },
        methods:{ 
            
        } 
    });
    var group = null;
    
    var styles = {
		top: 0,
		bottom: '60px',
		swipeBack:false,
		scrollIndicator: 'none', //是否显示滚动条
		scrollenabled: false,
		scalable: false,  //是否可缩放窗口
		background: "transparent",
		popGesture: 'none',  //是否右滑关闭
		bounce: 'none',  //回弹效果
		softinputMode: "adjustResize"  //默认：adjustPan
	}
    
    
    //初始化
    var initGroup = function () {
		var _self = plus.webview.currentWebview();
		_self.pathName = "首页";
		group = new webviewGroup(_self.id, this,true);
		console.log('_self:s'+JSON.stringify(_self))
		mui("#bartab").on("tap", "a", function(e) {
			vm.itemTab = this.getAttribute("index");
			var wid = this.getAttribute("data-wid");
			var islogin = this.getAttribute("data-login");
			if (!islogin || getState().token) {
				vm.tab = vm.itemTab;
				group.switchTab(wid);
			}else {
				pullfreshPage('/templates/user/login-frame.html', '/templates/user/login.html', '登录');
			}
		});
	}
    window.addEventListener('sendIndex',function(e){
		var wid="/templates/hot/hot-list-salesroom-frame.html"
		group.switchTab(wid);
    })
    
	var doms = $("#bartab a"),viewArr = [];
	
	mui.each(doms,function (index,element) {
		element.setAttribute("index",index);
		var pathName = element.getAttribute("data-name");
		viewArr.push({
			id: element.getAttribute("data-wid"),
			url: element.getAttribute("data-wid"),
			styles: styles,
			extras:{
				mType: 'main',
				pathName: pathName,
			}
		});
	});
	
	var obj = {
		items: viewArr,
		passiveListeners: false,
		onChange: function(obj) {
			vm.itemTab = obj.index;
			var target = doms[parseInt(vm.itemTab)];
			var islogin = target.dataset.login;
			if (!islogin || getState().token) {
				if(target.scrollIntoView) {
					vm.tab = vm.itemTab;
					target.scrollIntoView();
				}
			}else {
				pullfreshPage('/templates/user/login-frame.html', '/templates/user/login.html', '登录');
			} 
		} 
	}
	
	var viewsInit = function () {
		if (!arguments[0] || getState().token) { 
			initGroup.call(obj);
		}else {
			pullfreshPage('/templates/user/login-frame.html', '/templates/user/login.html', '登录',false,false,{_eff_:"none",mType: "main"});
			plus.webview.getWebviewById(login).addEventListener("loaded",function() {
				
				mui.later(function(){
					//关闭启动界面
			       plus.navigator.closeSplashscreen();  
				},100);
			})
			
		}
	}
	
	var appSet = {
		execute: function () {
			var _self = plus.webview.currentWebview();
			_self.pathName = "首页";
			isJournal && journal.sume.call(4);
			updates.check(appCode);
		}
	}
	
	//初始化
	var appSetView = {
		execute: function () {
			//先登录传true
			viewsInit(false); 
		}
	}
	var appInit = MacroCommand();
		appInit.add( appSet );
		appInit.add( appSetView );

	//处理推送跳转 
	function pushGetRun(payload) {
//      alert("进了推送")
		var obj = payload;
		if(typeof obj != "object" && obj.indexOf("{") != -1) {
			obj = JSON.parse(obj);
		}

		if(!obj.pushType) {
			return;
		}
		plus.runtime.setBadgeNumber(0);//清零角标
		if(mui.os.ios){//清零个推服务端角标
            var GeTuiSdk = plus.ios.importClass('GeTuiSdk');
            GeTuiSdk.setBadge(0);
    	}
		if(obj.pushType == 1) {
			if(getState().token) {
				changePage('/templates/order/order-info.html', '订单详情', {
					oId: obj.orderId,
					userNotificationId: obj.userNotificationId,
					isIndividualPush: true
				});
			} else {
				pullfreshPage('/templates/user/login-frame.html', 'templates/user/login.html', '登录');
			}
		} else if(obj.pushType == 2 || obj.pushType == 3) {
			if(obj.resourcesType  == -3){//供需资源
				changePage('templates/prod/supply-info.html', '资源详情', {
					pId: obj.resourceId,
					pType: (obj.resourcesType!= -3 ? obj.resourcesType : undefined),
					isIndividualPush: true
				});
				
			}else if(obj.resourcesType  == 3){//商城资源
				changePage('templates/prod/market-info.html', '资源详情', {
					pId: obj.resourceId,
					pType: (obj.resourcesType!= -3 ? obj.resourcesType : undefined),
					isIndividualPush: true
				});
				
			}else{//其他资源
				changePage('templates/prod/prod-info.html', '资源详情', {
					pId: obj.resourceId,
					pType: (obj.resourcesType!= -3 ? obj.resourcesType : undefined),
					isIndividualPush: true
				});
			}
		} else if(obj.pushType == 4) {
			changePage('templates/user/user-news-info.html', '公告详情', {
				noticeId: obj.noticeId,
				userNotificationId: obj.userNotificationId,
				isIndividualPush: true
			});
		}else if(obj.pushType == 6) {
			changePage('templates/user/bidConfirmation.html', '中标确认', {
				pId: obj.resourceId,
				isIndividualPush: true
			});
			pullfreshPage('/templates/user/user-quotes-list-frame.html', '/templates/user/user-quotes-list.html', '我的报价',{
				pId: val.resourceId,
				isIndividualPush: true,
				userNotificationId: "",
				tab:0,
				top:110
			});
		}

	}
	
	var isUpdateApp = function () {
		console.log(getState()[appCode])
		if (getState()[appCode]) {
			var state = getState();
			delete state[appCode]; //删除更新标志
			setState(state);
			var viewAll = plus.webview.all();
			viewAll.forEach(function (item) {
		  		if ( item.id != plus.runtime.appid && item.id != "HBuilder" && item.id!= _APPID_) {
		  			plus.webview.close(item, 'none', 0);
		  		}
			});
			mui.later(function(){
				plus.runtime.restart();
			},100);
		}
	}
	
	//js获取url传递参数，js获取url？号后面的参数
	function GetRequest(url) { 
		var theRequest = {}; 
		if (url.indexOf("?") != -1) { 
			var str = url.substring(url.indexOf("?")+1);
			strs = str.split("&"); 
			for(var i = 0; i < strs.length; i ++) { 
				theRequest[strs[i].split("=")[0]]=unescape(strs[i].split("=")[1]); 
			} 
		} 
		return theRequest; 
	} 
	var db = new DB('xhguide',1024);
	db.execute("create table if not exists guide(isguide varchar(255))");
	mui.plusReady(function() {	 
		appInit.execute();
		//updates.check(appCode); //检查更新
		window. addEventListener("show-index",function(e){ 
			var viewAll = plus.webview.all();
			viewAll.forEach(function (item) {
			  	if ( item.id != plus.runtime.appid && item.id != "HBuilder" && item.id!= _APPID_ && item.mType !='main') {
			  		plus.webview.close(item, 'none', 0);
			  	}
			});
		});
		setStatistic("index");
		journal.sume.call(4);

		db.fetch('select * from guide',function(ret){
			var ary = ret || [];
			if (ary.length>0) {
				//有值，说明已经显示过了，无需显示；
				//关闭splash页面；
				setTimeout(function() {
					plus.navigator.closeSplashscreen();
					plus.navigator.setFullscreen(false);
				}, 3000);
			} else {
				db.insert("guide",{isguide:true},function(res) {
					console.log("设置为已显示状态");
				});
				//显示启动导航
				mui.openWindow({
					id: 'guide',
					url: 'guide.html',
					styles: {
						popGesture: "none"
					},
					show: {
						aniShow: 'none'
					},
					waiting: {
						autoShow: false
					}
				});
			}
			
		});
		

		var scrollTop = 0;
		var doc = mui(".tab")[0];
		plus.webview.currentWebview().setStyle({
			softinputMode: "adjustResize"
		});


		plus.push.addEventListener("click", function(msg) {
			if(plus.os.name == "iOS"){
				mui.later(function(){
        			pushGetRun(msg.payload);	        	  
	        	},2000);
			}else{
				pushGetRun(msg.payload);
			}
			
		}, false);
		plus.push.addEventListener("receive", function(msg) {
			if(plus.os.name != "iOS") return; //判断IOS
			mui.later(function(){
    			pushGetRun(msg.payload);	        	  
        	},2000);
        	return;
		}, false);

	});

	/*监听焦点*/
	document.addEventListener("updateApp", function() {
		isUpdateApp();
	}, false);
	document.addEventListener("pause", function() {
		isUpdateApp();
		setStatistic("pause");
		plus.runtime.setBadgeNumber(0);//清零角标
		if(mui.os.ios){//清零个推服务端角标
            var GeTuiSdk = plus.ios.importClass('GeTuiSdk');
            GeTuiSdk.setBadge(0);
    	}
		journal.sume.call(3);
	}, false);
	document.addEventListener("resume", function() {
		setStatistic("resume");
		plus.runtime.setBadgeNumber(0);//清零角标
		if(mui.os.ios){//清零个推服务端角标
            var GeTuiSdk = plus.ios.importClass('GeTuiSdk');
            GeTuiSdk.setBadge(0);
    	}
		if(mui.os.ios && plus.webview.getTopWebview().id == "templates/user/settings.html") {
			mui.fire(plus.webview.getTopWebview(), 'upPush');
		}
		journal.sume.call(4);
	}, false);
	//监听第三方，打开APP指定页面
	document.addEventListener('plusready',function(){  
	    checkArguments();  
	},false);  
	// 判断启动方式  
	function checkArguments(){  
	    console.log("plus.runtime.launcher: "+plus.runtime.launcher);  
	    var args= plus.runtime.arguments;  
	    if(JSON.stringify(GetRequest(args)) !="{}" && GetRequest(args).resourceId){
		//if(args){  
			// 锤子手机args参数不是为空 ，其他手机正常
	        // 处理args参数，如打开新页面等
	        var obj = GetRequest(args)
			changePage('templates/prod/prod-info.html', '资源详情', {
				pId: obj.resourceId, 
				pType: (obj.resourcesType!= -3 ? obj.resourcesType : undefined),
				isIndividualPush: true
			});
	    }  
	}  
	// 处理从后台恢复  
	document.addEventListener('newintent',function(){  
	    checkArguments();  
	},false);  
})(window, mui)