(function(global,$){
	$.init({preloadLimit: 20});
	
	var hide = "mui-hidden";
	var hv = null,sv = null,at = 300;
	var activeTab = 1;
	var ainl = 'slide-in-left',
		ainr = 'slide-in-right',
		aoutl = 'slide-out-left',
		aoutr = 'slide-out-right';
	
	/*
	 * 预加载窗口
	 * @param {Array} obj : 循环的tab
	 * @param {URIString} arguments[0] : 是否显示等待框
	 * @param {boolean} arguments[1] : 是否需要先登录
	 */
	global.preload = function () {
//		plus.navigator.closeSplashscreen();
		var hrefs = this;
		
		var style = {top: 0,bottom: '51px'};
		var extras = {mType: 'main',pathName: null}
		
		if (arguments[0]) {
			sv = $.preload({
				url: arguments[0],
				id: arguments[0],
				styles: {top: 0,bottom: 0},
				extras: {mType: 'main',pathName: '登录'}
			});
		}
		
		var len = hrefs.length;
		function eachs (index,item) {
			extras.pathName = item.dataset.pathName;
			if (index == 0) {
				hv = $.preload({
					url: item.id,
					id: item.id,
					styles: style,
					extras: extras
				});
			}else {
				$.preload({
					url: item.id,
					id: item.id,
					styles: style,
					extras: extras
				});
			}
			
			if (index < len-1) { 
				index++;
				return mui.later(function(){
					eachs(index,hrefs[index]);
				},20);
			} return;
			
		}
		if (len) {
			eachs(0,hrefs[0]);
		}
		
		var vShow = function (va) {
			va.addEventListener('loaded', function() {
				setTimeout(function() {
					va.show();
				}, 100);
			});
		}
		
		if (arguments[1]) {
			if (getState().token) {
				
				vShow(hv);
			}else {
				vShow(sv);
			}
		}else {
			vShow(hv);
		}
		
		journal.sume.call(4);
	}
	
	global.tab = function () {
		
		var sHome = function () {
			var hrefs = this;
			var activeItem = arguments[0];
			activeTab = Number(activeItem)+1;
			$.each(hrefs,function (index,item) {
				if (index == activeItem) {
					item.classList.add('mui-active');
				}else {
					item.classList.remove('mui-active');
				}
			});
			var vId = hrefs[activeItem].id; 
			plus.webview.show(vId, ainl, at);
			plus.webview.hide( sv, aoutr, at);
			
		}
		
		
		var switchTo = function() {
			
			var targetTab = this.dataset.s;
			if(targetTab == activeTab) {return;}
			var tin = ainr,aout = aoutl;
			
			if (activeTab > targetTab) {
				tin = ainl;
				aout = aoutr;
			}
			
			var av = plus.webview.getTopWebview();
			var tv = this.id;
			
			if (this.dataset.login) {
				if (!getState().token) {
					tv = sv.id;
				}
			}
			
			plus.webview.show( tv, tin, at);
			plus.webview.hide( av.id, aout, at);
			if (plus.webview.getWebviewById(tv).children()[0]) {
				plus.webview.show(plus.webview.getWebviewById(tv).children()[0].id, tin, at);
			}
			journal.swit({pathName:plus.webview.getWebviewById(tv).pathName,pathUrl:plus.webview.getWebviewById(tv).id}, {pathName:av.pathName,pathUrl:av.id});
			activeTab = targetTab;
			if (plus.webview.getTopWebview().id=='/side.html'){
				mui.fire(plus.webview.getTopWebview(),'reloadNum');
			}	
		}
		
		return {
			sHome: sHome,
			switchTo: switchTo
		}
		
	}()
	
	
	
	
	$.plusReady(function () {
		plus.webview.currentWebview().pathName = '首页';
	    //checkForUpdates('http://10.6.73.52:8042/','A1001');  //检查版本
	    
	    $("#bartab").on("tap","a",function(){
			tab.switchTo.call(this);
		});
	});
	
	global.addEventListener("show-signin",function(e) {
		var state = getState();
			delete(state.token);
			setState(state);
		plus.webview.show( sv, ainr, at);
		
		var viewAll = plus.webview.all();
		
		$.later(function(){
			viewAll.forEach(function (item) {
		  		if ( item.id != plus.runtime.appid && item.mType !='main') {
		  			plus.webview.close(item, 'none', 0);
		  		}else if (item.mType =='main' && item.id != sv.id) {
		  			plus.webview.hide( item, 'none',0);
		  		}
			});
		},200);
	});
	
	global.addEventListener("login-success",function(e) {
		var item = 0;
		if (e.detail.type) {item = e.detail.type}
		tab.sHome.call($("#bartab a"),item);
	});
	
	global.addEventListener("call-home",function(e) {
		var viewAll = plus.webview.all();
		
		viewAll.forEach(function (item) {
			if (item.id != plus.runtime.appid && item.mType !='main' && item.mType !='sub') {
				plus.webview.close(item, 'none', 0);
			}
	    });
	});
	
	/*监听焦点*/
	document.addEventListener("pause", function () {
	    journal.sume.call(3);
	}, false);
	document.addEventListener("resume", function () {
	    journal.sume.call(4);
	}, false);	
	
})(window,mui)


