(function($){
	var interval = null;
	Vue.filter("toPrice",function (item) {
		 var reg = /^[0-9]+.?[0-9]*$/;
		  if (!reg.test(item)) {
		    return item;
		  }
		return "￥"+item;
		
	});
    vm = new Vue({
        el:".mui-content",
        data: {
            list: [],
            tab: 1,upTab: 1,search: false,wa: null,
            isShow:false,
            isIos:false,
            myData: {
            	headers: {'Content-Type': 'application/json'},
                filterText: "",
                categoryId: null,
                sorting:'',
                skipCount: 0,
				maxResultCount: 10
            },
            listType: {
                url: "",      //请求地址
                page: "skipCount",    //分页参数名
                limit: "maxResultCount",   //返回条数参数名
                acc: 10       //每次增加几页
            }
        },
        methods: {
        	openPage: function (pId,pType) {
        		
        		mui.fire(plus.webview.currentWebview().parent(),"inputUnFocus");// 搜索框失去焦点，收起小键盘
        		console.log("pType..:"+pType)
				if(pType === -3){
					changePage('../../templates/prod/supply-info.html', '资源详情', {
						pId: pId,
						pType: pType
					});
				}else if(pType === 3){
					changePage('../../templates/prod/market-info.html', '资源详情', {
						pId: pId,
						pType: pType
					});
				}else{
					changePage('../../templates/prod/prod-info.html', '资源详情', {
						pId: pId,
						pType: pType
					});
				}
        		//changePage('../../templates/prod/prod-info.html','资源详情',{pId:pId,pType: pType});
        	}, 
        	setList: function () { 
				var tmp = [];   
				
				tmp = this.list.map(function(item) {
					if (item.startTimeTotalSeconds > 0 ) {
		        		item = mui.extend(item,setTiem(item.startTimeTotalSeconds ))
						item.startTimeTotalSeconds --;   //预计开始秒数
						item.timeState = 1;
		        	}else {
		        		item.jdt = Math.abs((item.totalCount - item.totalSecounds) / item.totalCount * 100 );
		        		item = mui.extend(item,setTiem(item.totalSecounds ));
						item.totalSecounds--;   //总计剩余秒数
		        		item.timeState = 0;   
		        	}
		        	return item;
				});
				
				this.list = tmp;
			}
        }
    });
    
    var setTiem = function(t) {
		if(t > 0) {
			t = Math.floor(t * 1000);
			var h = Math.floor((t / 3600000) % 24); //带天数
			var m = Math.floor((t / 60000) % 60);  
			var s = Math.floor((t / 1000) % 60);

			var items = {
				d: Math.floor(t / 86400000),
				h: h < 10 ? "0" + h : h,
				m: m < 10 ? "0" + m : m,
				s: s < 10 ? "0" + s : s,
				content: ''
			}

			return items;

		} else {
			var items = {
				content: '已结束'
			}
			return items;
		}

	}               
	list = function() {

		return {
			upList: function(_type) {
				vm.nextStartDate = null;
				vm.myData.headers = {'Content-Type': 'application/json'};
				if (vm.tab != vm.upTab || vm.search ) {vm.list = [];} 
                clearInterval( interval ); 
                console.log('this.result：'+JSON.stringify(this.result))
                
				this.result.items.forEach(function (item) {
					var reg = new RegExp("-", "g"); //创建正则RegExp对象
					var currTime = new Date(item.currentTime).getTime();
					var starTime = new Date(item.bidStartTime).getTime();
					var endTime = new Date(item.bidEndTime).getTime();	
					vm.initDate = currTime; 
					
					if(currTime < starTime){
						item['isShow'] = true;
						item['txt'] = '开始时间：'+ new Date(item.bidStartTime).pattern("yyyy-MM-dd hh:mm:ss");
						if (!vm.minSt || starTime < vm.minSt) { //最小等待开拍
							vm.minSt = starTime; 
						}
					}else if(currTime > endTime){
						item['isShow'] = false;
						item['txt'] = '已结束';
					}else if(starTime <= currTime <= endTime){
						item['isShow'] = false;
						item['txt'] = '结束时间：' + new Date(item.bidEndTime).pattern("yyyy-MM-dd hh:mm:ss");
						if (!vm.minEt || endTime < vm.minEt) { //最小等待开拍
							vm.minEt = endTime;
						}
					}					
					vm.list.push(item);
					
				});
				if(vm.list.length == 0){
                	vm.isShow = false
                }else{
                	vm.isShow = true
                }
				console.log('处理后的数据：'+JSON.stringify(vm.list))
				if (vm.tab != vm.upTab || vm.search ) {
	    	    	if($.os.ios) {
						mui('#pullrefresh').pullRefresh().scrollTo(0,0,100);
					} else {
						mui.scrollTo(0, 100);
					}
	    	    	vm.wa.close();
	    	    } 
	    	    vm.upTab = vm.tab;
	    	    vm.search = false;
	    	    mui.fire(plus.webview.currentWebview().parent(),"banType",{ban: false});
				return closeList(_type, this.result.items.length);
			},
			resetList: function() {
				mui.fire(plus.webview.currentWebview().parent(),"banType",{ban: true});
                vm.myData.skipCount = 0;
			},
			err: function(xhe, type, thr) {
				vm.search = false;
            	mui.fire(plus.webview.currentWebview().parent(),"banType",{ban: false});
            	vm.wa&& vm.wa.close();
			}
		}
	}()

    var setURL = function (tab) {
    	switch (tab){
    		case 1:
        		vm.listType.url = BASE_appResource + "/QueryBiddingResourceList";
    			break;
    		case 2:
        		vm.listType.url = BASE_appResource + "/QueryTenderingResourceList";
    			break;
			case 3:
        		vm.listType.url = BASE_appResource + "/QueryBookResourceList";
    			break;
			case 4:
        		vm.listType.url = BASE_appResource + "/QueryProductList";
    			break;
    		default:
    		    vm.listType.url = BASE_appSupplyandDemandService + "/GetSupplyAndDemandsList";
    			break;
    	}
    	vm.myData.skipCount = 0;
    	vm.myData.headers = {'Content-Type': 'application/json'};
    	console.log(JSON.stringify(vm.myData))
    	console.log(JSON.stringify(vm.listType))
    	vm.$nextTick(function () {
    		return _init();
    	});
    }
    $.plusReady(function () {
    	if(mui.os.ios){			
			vm.isIos = true
		}else{			
			vm.isIos = false
		}
    	var curr = plus.webview.currentWebview();
    	vm.myData.filterText = curr.val;
    	vm.tab = curr.tab;
    	setURL(curr.tab);
       
       window.addEventListener("upList",function (e) {
       		console.log('categoryId:'+e.detail.cateId)
       		mui('#pullrefresh').pullRefresh().refresh(true);
       		vm.myData.filterText = e.detail.val;
       		vm.tab = e.detail.tab;
       		vm.myData.categoryId = e.detail.cateId || null;
       		vm.search = e.detail.search;
       		vm.wa = plus.nativeUI.showWaiting("", {
//							back: "none"
			});
       		setURL(e.detail.tab || '');
       });
       
       var time = 0;
        window.addEventListener('touchstart',function(event) {
        		time = new Date().getTime();
		},false);
		
		window.addEventListener('touchend', function(event) {
			if (time != 0 && mui.os.android) {
				var time2 = new Date().getTime();
				var num = Math.abs(time2 - time) / 1000;
				console.log("时差："+num)
				vm.list.forEach(function (item) {
					var start = Number(item.startTimeTotalSeconds) - num;
					var total = Number(item.totalSecounds) - num;
					item.startTimeTotalSeconds = start;	
					item.totalSecounds = total;	
				});
				time = 0;
			}
		}, false);
		
        window.addEventListener("scroll",function(event){
			if (mui.os.ios) {
				if (time != 0) {
					var time2 = new Date().getTime();
					var num = Math.abs(time2 - time) / 1000;
					vm.list.forEach(function (item) {
						var start = Number(item.startTimeTotalSeconds) - num;
						var total = Number(item.totalSecounds) - num;
						item.startTimeTotalSeconds = start;	
						item.totalSecounds = total;	
					});
					time = 0;
				}
			}
		},false);
       
    });
})(mui)