/** 
 * 保存更新日志
 */
var up_journal = function () {
	http.post(JOURNAL_URL+"/jplat-dcms-client/appDownLoadData/saveCount",{
		headers:{'Content-Type': 'application/json'},
		sysVersion: plus.os.name + plus.os.version,          //设备系统类型
		sysName: appCode,    				//app名称
		userName: getState().userName || '',			//用户名称
	},10000,function ( data ) {
		console.log("更新日志成功！");
	},function( xhr, type, hrow) {
		console.log("更新日志失败:"+xhr.status);
		error_code_handle(xhr, type, hrow);
	});
}


var checkWifi = function (callBack) {
	mui.ajax(LAN_URL,{
		data:{
		},
		dataType:'json',
		type:'get',
		timeout:2000,
		success:function(data){return callBack(true);},
		error:function(xhr,type,errorThrown){
			if (xhr.status == "200") {
				return callBack(true);
			}else {
				return callBack();
			}
		}
	});
}

/**
 * 下载资源包||整包 
 * */
function downWgt(wgtUrl, type){ 
	console.log("开始下载")
	type && plus.nativeUI.showWaiting("正在下载文件...",{back: "none"});
		plus.downloader.createDownload(JOURNAL_URL + wgtUrl, {filename:"_doc/update/",timeout: 0}, function(d,status){
			if ( status == 200 ) { 
				up_journal();
			    installWgt(d.filename, type); // 安装wgt包
			} else {
			    plus.nativeUI.alert("下载包失败！");
			}
			    type && plus.nativeUI.closeWaiting();
		}).start();
	}

/**
 * 重启标识
 */

function restartFn () {
	var state = getState();
		state[appCode] = true;
		setState(state);
}
		
/**
 * 安装
 * */
function installWgt(path, type){
	type && plus.nativeUI.showWaiting("正在安装...",{back: "none"});
	plus.runtime.install(path,{},function(){
		restartFn();
		
		if (type) {
			plus.nativeUI.closeWaiting();
			mui.later(function(){
				mui.fire(plus.webview.getLaunchWebview(),'updateApp',{});
			},200);
		}
		
	},function(e){
		type && plus.nativeUI.closeWaiting();
	    plus.nativeUI.alert("安装文件失败["+e.code+"]："+e.message);
	});
}


var updates = (function () {
	var arg,vs,appKey,callBack;
	
	function deleteObj () {
		arg = null;
		vs = null;
		appKey = null;
		callBack = null;
	}
	
	
	function vApk (data,type) {
		
		if (type != 'apk' && !Number(data.force)) {
			downWgt(data.url );
		}else {
			return "next";
		}
	}
	
	function vios (data,type) {
		if (mui.os.ios && type == 'apk') {
			plus.runtime.openURL(data.iosUrl);
		}else {
			return "next";
		}
	}
	
	function vandroid (data,type) {
		plus.nativeUI.confirm(data.remark || "暂无日志", function(event) {
			if (0 == event.index) {
				downWgt(data.url, true );
			}
		}, data.name, ["立　　即", "取　　消"]);
	}
	
	
	
	
	return {
		/** 
		 * 少量更新依次下载安装
		 */
		fewDown: function () {
			var arr = this;
			var i = 0,len = arr.length;
			
			function downs () {
				if (i<len) {
					//下载
					if (arr[i].url.slice(-4) == 'wgtu') {
						plus.downloader.createDownload(JOURNAL_URL+arr[i].url, {filename:"_doc/update/",timeout: 0}, function(d,status){
							if ( status == 200 ) {
								//安装
								up_journal();
							    plus.runtime.install(d.filename,{},function(){
							    	i++;
							    	mui.later(function(){
							    		downs();
							    	},500)
								},function(e){
									plus.nativeUI.toast("安装文件失败["+e.code+"]："+e.message);
									i++;
									mui.later(function(){
							    		downs();
							    	},500)
								});
							} else {
								plus.nativeUI.toast("下载更新资源失败！");
								i++;
								mui.later(function(){
						    		downs();
						    	},500)
							}
						}).start();
					}else {
						i++;
						return downs();
					}
					
				}else {
					var fn = callBack;
					deleteObj();
					if (fn) {return fn(arr,true)};
					
					return restartFn();
				}
			}
			downs();
		},
		/** 
		 * 少量更新检查
		 */
		few: function () {
			
			mui.ajax(JOURNAL_URL +'/jplat-dcms-client/appVersion/getDiffList',{
				headers: {'Content-Type': 'application/json'},
				data:{
					appVersion: vs,
					appKey: appKey 
				},
				dataType:'json',//服务器返回json格式数据
				type:'post',//HTTP请求类型
				success:function(data){
					if (data.data) {
						updates.fewDown.call(data.data);
					}else {
						return deleteObj();
					}
				},
				error:function(xhr,type,errorThrown){
					deleteObj();
					console.log("失败："+xhr.status);
				}
			});
			
		},
		/** 
		 * 整包升级
		 */
		full: function (i) {
			
			mui.ajax(JOURNAL_URL +'/jplat-dcms-client/appVersion/getLast',{
				data:{
					version: vs,   
					appKey: appKey
				},
				dataType:'json',
				type:'post',
				timeout:10000,
				success:function(data){
					console.log("更新："+JSON.stringify(data))
					if (data.success) { 
						if (data.data) {
							var vs1 = parseInt(data.data.appVersion.replace(/\./g,""));
							var vs2 = parseInt(vs.replace(/\./g,""));
							//检查整包&资源包
							if (vs1 > vs2) {   
								var fn = callBack;
								var fType = data.data.url.slice(-3);
								deleteObj();
								
								//自定义处理
								if (fn && fType != 'apk') {
									return fn(data);
								}
								//默认处理
								console.log("默认处理")
								var res = vApk.asyAfter( vios ).asyAfter( vandroid );
								res( data.data, fType );
								
							}else {
								//检查差量更新
								updates.few();
							}
						}else {
							updates.few();
						}
					}
				},
				error:function(xhr,type,errorThrown){
					console.log("更新err："+i)
					if (i<10) {
						i++;
						mui.later(function(){
							updates.full(i);
						},5000)
					}
				}
			});
		},
		check: function () {
			arg = arguments;
			
			for(var i in arg) {
				switch (typeof arg[i]){
					case 'string':
						appKey = arg[i];
						break;
					case 'function':
						callBack = arg[i];
						break;
					default:
						break;
				}
			} 
			 
			plus.runtime.getProperty(plus.runtime.appid,function(v){    //获取当前app版本
				plus.storage.setItem("version",v.version);
				vs = v.version; 
				checkWifi(function (isLAN) {
					if (isLAN) {
						JOURNAL_URL = "http://10.130.0.152:8042";
					}
					return updates.full(1);
				})
				
			});
		}
	}
})()

