
(function($) {				
	var vm = new Vue({
		el: '.mui-content',
		data: {		
			phone:'',
			isPhoneCode: false, // 是否发送了验证码
			phoneCodeBtnText: '获取验证码',
			codeNum:'',
			isState: { // 显示状态 0表示未验证 	1表示验证成功 		2表示验证错误
				phoneNumber: 0,
				codeNum: 0,
				newPassword: 0,
				newPasswordConfirm: 0
			}
		},
		mounted:function(){
			var _this = this;
			$.plusReady(function() {
//				if(/^\d{11}$/.test(plus.webview.currentWebview().phone)){
//					_this.param.phoneNumber = plus.webview.currentWebview().phone;
//				}
			})
		},
		methods: {
			resetPwd: function(ev) {//下一步
				setStatistic("resetPwd");
    			ev.target.focus(); //按钮获取焦点关闭软键盘														
				this.checkSmsCode();
			},
			getPhoneCode: function() {//获取手机验证码 
				setStatistic("getPwdValidNum");
				var _this = this;													
				_this.isState.phoneNumber = 1;
				_this.isPhoneCode = true;
				_this.phoneCodeBtnText = '正在获取...';
				http.post(BASE_appUser+'/GetCurrentUserPhoneCode',{},function(data) {
					if (data.success) {
						var time = 60;
						var setTimer = setInterval(function() {
							if(time == 0){
								_this.isPhoneCode = false;
								_this.phoneCodeBtnText = '获取验证码';
								clearInterval(setTimer);
							}else{
								_this.isPhoneCode = true;
								_this.phoneCodeBtnText = time + 's后重新获取';
								time--;
							}														
						},1000);
					} else {
						_this.isPhoneCode = false;
						_this.phoneCodeBtnText = '获取验证码';
						$.toast(data.result);
					}
				}, function(xhr, type, thr) {
					_this.isState.phoneNumber = 2;
					_this.isPhoneCode = false;
					_this.phoneCodeBtnText = '获取验证码';
					var result = JSON.parse(xhr.response);
					$.toast(result.error.message)
				});
			},
			checkSmsCode: function() {//判断手机验证码是否正确
				var ws = plus.nativeUI.showWaiting();
				var _this = this;
				if (this.codeNum == "") {
					_this.isState.codeNum = 2;
					$.toast("请输入手机短信验证码")
					ws.close()
					return; 
				}							
				http.post(BASE_appUser+'/ValidateCurrentUserVerifyCode  ', {
					id: this.codeNum
				}, function(data) {
					ws.close()
					console.log('判断手机验证码是否正确::;'+JSON.stringify(data))
					_this.isState.codeNum = data.success == true ? 1:0;
					changePage("/templates/user/changePhoneNext.html","修改手机号",{});
				}, function(xhr, type, thr) {
					ws.close()
					_this.isState.codeNum = 2;
				});
			},								
		}
	})
	$.plusReady(function() {
		vm.phone = plus.webview.currentWebview().phone
		setStatistic("forgetPwd");
	});
})(mui);
