(function($) {
	var CDATE = new Date();
	var ztTime = new Date(CDATE.getFullYear(), (CDATE.getMonth()), CDATE.getDate(), "00", "00").getTime();
	Vue.filter("times",function(num){ 
        var num = num.split('T')[0]; 
        return num;
    });
	Vue.filter("toTime", function(str) {
		var time = new Date(str);

		if(Math.abs(ztTime - 24 * 60 * 60 * 1000) <= Math.abs(time.getTime()) && Math.abs(time.getTime()) < Math.abs(ztTime)) {
			return "昨天 " + time.pattern("HH:mm:ss");
		} else if(Math.abs(ztTime) <= Math.abs(time.getTime())) {
			return "今天 " + time.pattern("HH:mm:ss");
		} else {
			return time.pattern("yyyy-MM-dd HH:mm:ss");
		}
	});
	Vue.filter("toName", function(type) {
		if(type == 1) {
			return '中标';
		} else if(type == 2) {
			return '公告';
		} else if(type == 3) {
			return '流标';
		} else if(type == 4) {
			return '上架';
		}else if(type == 6) {
			return '拆标';
		}
	});

	vm = new Vue({
		el: ".mui-content",
		data: {
			wa: null,
			isLogin: false,
			isShow: false,
			list: [],
			myData: {
				messageType:1,
				sorting:'',
				skipCount: 0,
				maxResultCount: 10,
			},
			listType: {
				url: BASE_appMessage + "/GetMessageList", //请求地址
				page: "skipCount", //分页参数名 
				limit: "maxResultCount", //返回条数参数名
				acc: 10 //每次增加几页
			}
		}, 
		methods: {
			openPage: function(val) {
				val.isRead = true;
				console.log('userMessageType:'+val.userMessageType)
				if(val.userMessageType == 1) {
					changePage('/templates/order/order-info.html', '订单详情', {
						oId: val.relationId,
						userNotificationId: val.id
					});
				} else if(val.userMessageType == 2) {
					changePage('user-news-info.html', '公告详情', {
						noticeId: val.relationId,
						userNotificationId: val.id
					});
				} else if(val.userMessageType == 6) {
					pullfreshPage('/templates/user/user-quotes-list-frame.html', '/templates/user/user-quotes-list.html', '我的报价',{
						pId: val.relationId,
						isIndividualPush: false,
						userNotificationId: val.id, 
						tab:0,
						top:110
					}); 														
				}else if(val.userMessageType == 5){//供需资源
					changePage('/templates/prod/supply-info.html', '资源详情', {
						pId: val.relationId,
						pType: (val.userMessageType == 5 ? undefined : 1 ),
						userNotificationId: val.id
					});
				}else if(val.userMessageType == 7){//商城资源
					changePage('/templates/prod/market-info.html', '资源详情', {
						pId: val.relationId,
						pType: (val.userMessageType == 5 ? undefined : 1 ),
						userNotificationId: val.id
					});
				}else{
					changePage('/templates/prod/prod-info.html', '资源详情', {//其他资源
						pId: val.relationId,
						pType: (val.userMessageType == 5 ? undefined : 1 ),
						userNotificationId: val.id
					});
				}

			},
			delData:function(i){//删除
				console.log("当前ID："+vm.list[i].id)
				delNews(vm.list[i].id)
			}
		}
	})

	list = function() {
		return {
			upList: function(_type) {
				
				this.result.items.forEach(function(item) {
					vm.list.push(item);
				});  
				if(vm.list.length == 0){
                	vm.isShow = false
                }else{
                	vm.isShow = true
                }
                vm.wa&& vm.wa.close();
				mui.fire(plus.webview.currentWebview().parent(),'sendLen',{len:vm.list.length});
				mui.fire(plus.webview.currentWebview().parent(),'sendwa',{}) 
                return _closeList(_type,this.result.totalCount , vm.list.length);

			},
			resetList: function() {
				vm.myData.skipCount = 0; 
			},
			err: function(xhe, type, thr) {
				vm.wa&& vm.wa.close();
				mui.fire(plus.webview.currentWebview().parent(),'sendwa',{})
				if(mui.os.ios) {
					mui('#pullrefresh').pullRefresh().scrollTo(0,0,100);
				} else {
					mui.scrollTo(0, 100);
				}

			}
		}
	}()
	//删除
	var delNews = function(id) {
		http.post(BASE_appMessage + "/DeleteMessage", {
			ids:[id]					
		}, function(data) {
			//console.log('删除返回数据：'+JSON.stringify(data))
			if(data.success){
				mui.toast('删除成功')
				mui.later(function(){
					Refresh() 
				},500)
			}
		});
	}
    //刷新 
    function Refresh(){
        vm.myData.skipCount = 0; 
        vm.list=[];
        mui.later(function() {
            mui('#pullrefresh').pullRefresh().pullupLoading();
            if(mui.os.ios){
                mui('#pullrefresh').pullRefresh().scrollTo(0,0,100);
            }
        }, 0);
    }
	$.plusReady(function() {
		vm.wa = plus.nativeUI.showWaiting("", {back: "none"});
		console.log(plus.webview.currentWebview().id)
		window.addEventListener('sendNum',function(e){
			vm.myData.messageType = e.detail.tab;
			Refresh()
			if(getState().token) {
				vm.isLogin = true; 
			}
		})
		setStatistic("newsList", {});
		if(getState().token) {
			vm.isLogin = true; 
		}
		
		mui.later(function(){
			_init();
		},1000)
	});
})(mui)