(function(mui){
	var interval = null;
	Vue.filter("toPrice",function (item) {
		 var reg = /^[0-9]+.?[0-9]*$/;
		  if (!reg.test(item)) {
		    return item;
		  }
		return "￥"+item;
	});
    vm = new Vue({
        el:".mui-content",
        data: {
        	wa: null,tabType: false,
            list: [],
            isShow:false,
            isIos:false,
            myData: {
            	biddingState:0,
                skipCount: 0,
                maxResultCount: 10,
                resourceId:0,
                userNotificationId :'',
                isIndividualPush:false,
            },
            listType: {
                url:BASE_appBidding+"/GetBidding",      //请求地址
                page: "skipCount",    //分页参数名
                limit: "maxResultCount",   //返回条数参数名
                acc: 10       //每次增加几页
            }
        },
        methods: {
        	openPageTwo:function(type,pId,pType,isWaste){
        		console.log('isWaste:'+isWaste)
        		if(isWaste){
        			changePage('../prod/prod-buy-waste.html','继续报价',{pId:pId,pType: pType});
        		}else{
        			changePage('../prod/prod-buy.html','继续报价',{pId:pId,pType: pType});
        		}
        	},
        	openPage: function (type,pId,pType) {                    	
        		switch (type){
        			case 'quotes':
        				changePage('see-quotes.html','查看报价',{pId: pId ,isWaste:pType}); 
        				break;
        			case 'order':
        				changePage('../order/order-info.html','订单详情',{oId: pId});
        				break;
        			case 'offerPrice':
        				changePage('../prod/prod-buy.html','继续报价',{pId:pId,pType: pType});
        				break;
 				
        			case 'certificate':
        				setStatistic("BiddingNotice");
        				changePage('see-quotes-certificate.html','中标通知书',{pId: pId});
        				break;
        			case 'prod':
        				changePage('../prod/prod-info.html','资源详情',{pId:pId,pType: pType});
        				break;
    				case 'confirm':
        				changePage('bidConfirmation.html','中标确认',{pId:pId});
        				break;
        			default:
        				return;
        				break;
        		} 
        	}, 
        	setList: function () {
				var tmp = [];

				tmp = this.list.map(function(item) {
	        		item.jdt = Math.abs((item.totalCounts - item.totalSecounds) / item.totalCounts * 100 );
					item.totalSecounds--;   //总计剩余秒数
	        		item.timeState = 0;
		        	return item;
				});

				this.list = tmp;
			}
        }
    });

    var setTiem = function(t) { 
		if(t > 0) {
			t = Math.floor(t * 1000);

			var h = Math.floor((t / 3600000) % 24); //带天数
			var m = Math.floor((t / 60000) % 60);
			var s = Math.floor((t / 1000) % 60);

			var items = {
				d: Math.floor(t / 86400000),
				h: h < 10 ? "0" + h : h, 
				m: m < 10 ? "0" + m : m,
				s: s < 10 ? "0" + s : s,
				content: ''
			}

			return items;

		} else {
			var items = {
				content: '已结束'
			}
			return items;
		}
	}
                  
    list = function () {
        return {
            upList: function (_type) {
            	clearInterval( interval );
                if (vm.tabType) {vm.list = [];
                	if(mui.os.ios) {
						mui('#pullrefresh').pullRefresh().scrollTo(0,0,100);
					} else {
						mui.scrollTo(0, 100);
					}
                }             
                this.result.items.forEach(function(item) {
                	var reg = new RegExp("-", "g"); //创建正则RegExp对象
					var currTime = item.currentTime;
					var starTime = item.bidStartTime;
					var endTime = item.bidEndTime;
					if(item.isSplit && item.confirmStartTime && item.confirmEndTime){
						currTime = item.currentTime;
						starTime = item.confirmStartTime;
						endTime = item.confirmEndTime;
					}
					var data = {
						nowdate: new Date(currTime).getTime(),
						startdate: new Date(starTime).getTime(),
						enddate: new Date(endTime).getTime(),
						setday: 0,
						init: false  
					} 
					item['dates'] = {
						step: 3,
						d: null,
						h: null,
						m: null,
						s: null,
						jdt: 0 
					};
	
					item['timeInter'] = $.leftTime(data, function(d) {
						if(d.status) {									
							//d.status 状态 1未开始，2已开始，3已结束
							//d.d 天
							//d.h 时
							//d.m 分
							//d.s 秒
							item['dates'].step = d.step;
							item['dates'].d = d.d;
							item['dates'].h = d.h;
							item['dates'].m = d.m;
							item['dates'].s = d.s;
	
							var ss = Number(d.d) * 24 * 60 * 60 * 1000 +
								Number(d.h) * 60 * 60 * 1000 +
								Number(d.m) * 60 * 1000 +
								Number(d.s) * 1000;
							//进度条
							ss = ss / 1000;
	
							item['dates'].jdt = Math.abs((item.totalSecond - ss) / item.totalSecond * 100);
						} else if(d.step == 1 || d.step == 2) {
							mui.fire(plus.webview.getWebviewById('/side.html'),'reloadNum',{});
							item['dates'].step = 3;
							var items = {
								content: '已结束'
							}
							return items;
						}
					});
                	
                	vm.list.push(item);
                });
                if(vm.list.length == 0){
                	vm.isShow = false
                }else{
                	vm.isShow = true
                }
                vm.wa&& vm.wa.close();
                vm.tabType = false;
                mui.fire(plus.webview.currentWebview().parent(),'setTabType',{isTab: true});
                mui.fire(plus.webview.getWebviewById('/side.html'),'reloadNum',{});
                return closeList(_type, this.result.items.length);
            },
            resetList: function () {
            	mui.fire(plus.webview.currentWebview().parent(),'setTabType',{isTab: false});
            	mui.fire(plus.webview.getWebviewById('/side.html'),'reloadNum',{});
                vm.myData.skipCount = 0;
            },
            err: function (xhr,type,thr) {
            	vm.wa&& vm.wa.close();
            	mui.fire(plus.webview.currentWebview().parent(),'setTabType',{isTab: true});
            	mui.fire(plus.webview.getWebviewById('/side.html'),'reloadNum',{});
            }
        }
    }()
    mui.plusReady(function () {
    	if(mui.os.ios){			
			vm.isIos = true
		}else{			
			vm.isIos = false
		}
    	var curr = plus.webview.currentWebview();
		curr.setStyle({bounceBackground : '#FFFFFF'})
    	vm.myData.biddingState =curr.tab;
    	vm.myData.resourceId = curr.pId || 0;
    	vm.myData.userNotificationId = curr.userNotificationId || "";
    	vm.myData.isIndividualPush = curr.isIndividualPush || false;
    	console.log('参数biddingState：：：：'+vm.myData.biddingState)
    	console.log('参数：：：：'+JSON.stringify(vm.myData))
       _init();

       window.addEventListener("tabList",function (e) {
       		switch (e.detail.tab){
       			case 0:
       			setStatistic("quotePriceAll",{});
       			break;
       			case 1:
       			setStatistic("quotingPrice",{});
       			break;
       			case 2:
       			setStatistic("winBidding",{});
       			break;
       			case 3:
       			setStatistic("loseBidding",{});
       			break;
       			case 4:
       			setStatistic("failureBidding",{});
       			break;
       			
       			
       		}
       		mui('#pullrefresh').pullRefresh().refresh(true);
       		vm.myData.biddingState = e.detail.tab;
       		vm.tabType = true;
       		vm.myData.skipCount = 0; 
       		vm.wa = plus.nativeUI.showWaiting("", {
				back: "none"
			});
			if(mui.os.ios) {
				mui.later(function(){
					mui('#pullrefresh').pullRefresh().scrollTo(0,0,100);
				},100)
			} else {
				mui.scrollTo(0, 100);
			}

			_init();
       });
       
       window.addEventListener("updateList",function (e) {
       		mui('#pullrefresh').pullRefresh().refresh(true);
       		vm.tabType = true;
       		vm.myData.skipCount = 0;
       		_init();
       });
       
       var time = 0;
        window.addEventListener('touchstart',function(event) {
        		time = new Date().getTime();
		},false);
		
		window.addEventListener('touchend', function(event) {
			if (time != 0 && mui.os.android) {
				var time2 = new Date().getTime();
				var num = Math.abs(time2 - time) / 1000;
				console.log("时差："+num)
				vm.list.forEach(function (item) {
					var total = Number(item.totalSecounds) - num;
					item.totalSecounds = total;	
				});
				time = 0;
			}
		}, false);
		
        window.addEventListener("scroll",function(event){
			if (mui.os.ios) {
				if (time != 0) {
					var time2 = new Date().getTime();
					var num = Math.abs(time2 - time) / 1000;
					vm.list.forEach(function (item) {
						var total = Number(item.totalSecounds) - num;
						item.totalSecounds = total;
					});
					time = 0;
				}
			}
		},false);

    });
})(mui) 