var downloadFile = {
	downWgt : function( _path,v ){//下载成功返回保存地址
		var wa = plus.nativeUI.showWaiting("正在下载文件...", {
//			back: "none"
		});
		var downloadOptions = {
			timeout: 60,
			filename: '_doc/update/',
			retry: 2,
			retryInterval: 10
		};
		plus.downloader.createDownload(_path, downloadOptions, function(d, status) {
			var completion = '';
			if(status == 200) {
				completion = d.filename;
				wa.close();
				mui.toast('下载完成');
				plus.runtime.openFile(d.filename, function(e) {
					mui.toast('打开失败，请安装第三方支持软件');
				});
			} else {
				wa.close();
				mui.toast("下载文件失败！");
			}
			
			return completion;//返回下载保存的路径
		}).start();
	},
	showFile: function(_path) {//打开文件
		plus.runtime.openFile(_path,function(e){
			mui.toast('打开失败，请安装第三方支持软件');
		});
	},
	createUpload: function(_url, data, fileArr,fun){//创建上传任务  _url(上传地址), data(参数), fileArr(上传文件数组),fun(监听回掉)
		var task = plus.uploader.createUpload( _url , data,
			function ( t, status ) {
				// 上传完成
				if ( status == 200 ) { 
					alert( "Upload success: " + t.url );
				} else {
					alert( "Upload failed: " + status );
				}
			}
		);
		
		fileArr.forEach(function(item){
			/*task.addFile( "_www/a.doc", {key:"testdoc"} );
			task.addData( "string_key", "string_value" );*/
			task.addFile( item.path);
		});
		
		task.addEventListener( "statechanged", fun, false );
		
		task.start();
	},
	onStateChanged: function( upload, status){
		if ( upload.state == 4 && status == 200 ) {
			// 上传完成
			mui.toast( "上传完成:" + upload.getFileName() );
		}
	}
}
