(function(global, mui) {
	var main = null;
	var menu = null;
	var isInTransition = false;
	var showMenu = false;
	var interval = null;

	Vue.filter("toNet", function(val) {
		if(val >= 10000) {
			val = Number(val / 10000);
		}
		return accounting.formatMoney(val, '', 3);
	});

	Vue.filter("toMoney", function(val) {
		if(val >= 10000) {
			val = Number(val / 10000);
		}
		return accounting.formatMoney(val, '', 2);
	});
	Vue.filter("times",function(num){ 
        var num = num.split('T')[0]; 
        return num;
    });
	vm = new Vue({
		el: ".mui-content",
		data: {
			nextStartDate: null,
			isIos: false,
			ios5: false,
			isShow: false,
			dx: null,
			dy: null,
			fixed: false,
			news: false,
			numberofcases: 0,
			labelVolmoney: 0,
			registerUser: 0,
			imgArr: [],
			hotList: [],
			list: [],
			noticeList: [],
			tab: 1,
			tabUp: 0,
			wa: null,
			myData: {
				resourcesType: 4,
				skipCount: 0,
				maxResultCount: 10
			},
			listType: {
				url: BASE_appResource + "/GetResourceList", //请求地址
				page: "skipCount", //分页参数名
				limit: "maxResultCount", //返回条数参数名
				acc: 10 //每次增加几页 
			},
			cerficationImg: './images/membersPower/icon_cx@2x.png', // 长协图标
			registerImg: 'images/membersPower/icon_zc@2x.png', // 注册图标
			verifiedImg: 'images/membersPower/img_rz@2x.png', // 已认证图标
			southwest: 0, // 西南地区废钢指数
			frontData:[], // 数据前六条城市数据
			animate: false,
			horseLampList:[]//公告滚动
			
		},
		created: function () {
//          setInterval (this.showhorseLamp, 1500)
        },
		methods: {
//			showhorseLamp: function () {
//          	var _this = this;
//              _this.animate = true;
//              setTimeout (function() {
//                  _this.horseLampList.push(_this.horseLampList[0]);
//                  _this.horseLampList.shift();
//                  _this.animate = false;
//              }, 2000);
//              
//          },
			changePages:function(i){
				console.log(i)
				mui.fire(plus.webview.getLaunchWebview(), "sendIndex", {tab:i});
				
				mui.later(function(){
					mui.fire(plus.webview.getWebviewById('/templates/hot/hot-list-salesroom-frame.html'),'sendHot',{tab:i});
				},500)
					
			},
			increaseToPage: function() {
				setStatistic("more");
				changePage('../../templates/scrapIndex/data-cal-frame.html','数据统计');
			},
			callTop: function() {
				scrollSearch();
			},
			openPage: function(pId, pType) {
				console.log("pType..:"+pType)
				var str ='offerPrice';
				if(pType == 0 || pType == 5){
					str = 'offerPrice'
				}else{
					str = 'reloadPrice'
				}
				setStatistic(str);
				changePage('../../templates/prod/prod-info.html', '资源详情', {
					pId: pId,
					pType: pType
				});
			}, 
			changeNotice:function(){
				pullfreshPage('../user/user-notice-list-frame.html', '../user/user-notice-list.html', '公告',{});

			},
		
			changeSearch:function(){
				setStatistic("presearch");
			}
		}
	})
	var getAnnounce = function() {
			http.post(BASE_appMessage + "/GetAnnouncementList", {
			
		}, function(data) {
			console.log('首页公告：'+JSON.stringify(data));
			vm.noticeList = data.result;
//			vm.horseLampList = data.result;
		});
	}
	var scrollSearch = function() {
		var docTop = Number(mui(".tab")[0].offsetTop) - 55;
		if(mui.os.ios) {
			mui('#pullrefresh').pullRefresh().scrollTo(0, docTop, 100)
		} else {
			mui.scrollTo(docTop, 100);
		}
	}

	var getImg = function() {
		http.post(BASE_appIndexpageService + "/GetIndexBanner", function(data) {
			vm.imgArr = data.result.map(function(item) {
				return {
					url: item.advertisementImageUrl
				};
			});
			vm.$nextTick(function() {
				var gallery = mui('.mui-slider');
				gallery.slider({
					interval: 3000 //自动轮播周期，若为0则不自动播放，默认为0；
				});
			});
		});
	}
	var getHot = function() {
		vm.hotList.forEach(function(item) {
			if(item.timeInter) {
				window.clearInterval(item.timeInter);
			}
		});
		http.post(BASE_appResource + "/GetHotResource", function(data) {
			console.log("热门：" + JSON.stringify(data));
			if(data.result.length == 0){
            	vm.isShow = false
            }else{
            	vm.isShow = true
            }
			vm.hotList = [];
			vm.nextStartDate = null;
			vm.hotList = data.result.map(function(item) { 
				var reg = new RegExp("-", "g"); //创建正则RegExp对象
				var currTime = item.currenTime;
				var starTime = item.bidstarttime.replace(reg, "/");
				var endTime = item.bidendtime.replace(reg, "/");
				var data = {
					nowdate: new Date(currTime).getTime(),
					startdate: new Date(starTime).pattern("yyyy/MM/dd HH:mm:ss"),
					enddate: new Date(endTime).pattern("yyyy/MM/dd HH:mm:ss"),
					setday: 0,
					init: false
				}							
				var isStart = (new Date(currTime).getTime() >= new Date(starTime).getTime());				
					item['dates'] = {
						step: 1,
						d: null,
						h: null,
						m: null,
						s: null,
						jdt: 0
					};
				if (isStart) {
					item['timeInter'] = $.leftTime(data, function(d) {
						if(d.status) {
							//d.status 状态 1未开始，2已开始，3已结束
							//d.d 天
							//d.h 时
							//d.m 分
							//d.s 秒
							item['dates'].step = d.step;
							item['dates'].d = d.d;
							item['dates'].h = d.h;
							item['dates'].m = d.m;
							item['dates'].s = d.s;

							var ss = Number(d.d) * 24 * 60 * 60 * 1000 +
								Number(d.h) * 60 * 60 * 1000 +
								Number(d.m) * 60 * 1000 +
								Number(d.s) * 1000;
							//进度条
							ss = ss / 1000;
							item['dates'].jdt = Math.abs((item.totalCounts - ss) / item.totalCounts * 100);
						} else if(d.step == 1 || d.step == 2) {
							item['dates'].step = 3;
							getHot();
						}
					});
				}else if (!vm.nextStartDate) {
					vm.nextStartDate = new Date(starTime).getTime();
				}				
				var itemArr = item.thumbnailResourceAttaches;
				if(itemArr) {
					if(itemArr.length == 2) {
						item.thumbnailResourceAttaches.push(itemArr[itemArr.length - 1]);
					} else if(itemArr.length == 1) {
						item.thumbnailResourceAttaches.push(itemArr[itemArr.length - 1]);
						item.thumbnailResourceAttaches.push(itemArr[itemArr.length - 1]);
					} else {
						item.thumbnailResourceAttaches.length = 3;
					}
				} else {
					for(var i = 0; i < 3; i++) {
						item.thumbnailResourceAttaches.push({
							url: "images/60x60.gif"
						});
					}
				}
				return item;
			}); 
			console.log("热门资源length："+vm.hotList.length)  
			console.log("hotList:"+JSON.stringify(vm.hotList))  
		}); 
	}	
	var exponent = function() { // 获取西南废钢指数
		var getMapTime = function() {
			//判断今天是不是12点之前，不是则数据显示昨天的数据
			//先判断是不是周末 如果周末则显示周一的数据
			//如果昨天是周末，显示周一的数据 
			var date = new Date();
			var hours = date.getHours();
			if(hours < 12) {
				date.setDate(date.getDate() - 1);
				console.log(new Date(date).pattern('yyyy-MM-dd'));
			}
			var time = date.getDay();
			time == 0 && date.setDate(date.getDate() - 2);
			time == 6 && date.setDate(date.getDate() - 1);
			return new Date(date).pattern('yyyy-MM-dd');
		}();	
		var getPrice = function(price, obj) { //西南废钢指数规则
			if(obj.price == '-') {
				return price;
			}
			switch(obj.city) {
				case "成都":
					return price += obj.price * 0.4;
					break;
				case "重庆":
					return price += obj.price * 0.1;
					break;
				case "昆明":
					return price += obj.price * 0.3;
					break;
				case "六盘水":
					return price += obj.price * 0.2;
					break;
			}
		};
		
		mui.ajax(FG_URL + 'v1/mysteel/scope/query', {
			data: {
				startdate: getMapTime,
				enddate: getMapTime,
				product: 'fg'
			},
			dataType: 'json',
			type: "get",
			success: function(data, status, xhr) {
				//console.log("废钢指数当前的数据"+JSON.stringify(data));
				if(data.code == 1) {
					var res = data.data,
					money = 0;
					vm.frontData = [];
					for(var i = 0; i < res.length; i++) {
						// 首页的6个城市随意显示张家港、上海、宁波、济南、唐山、辽阳、武汉、北京中的6个，因为全国主要城市数据在详情页只有这8个城市的数据
						if(res[i].city == "北京" || res[i].city == "上海" || res[i].city == "唐山" || res[i].city == "宁波" || res[i].city == "济南" || res[i].city == "武汉") {
							vm.frontData.push(res[i]);
						}
						// 计算西南废钢指数
						if(res[i].city == "成都" || res[i].city == "重庆" || res[i].city == "昆明" || res[i].city == "六盘水") {
							money = getPrice(money, res[i]);
						}
					}
					vm.southwest = money;
				} else {
					mui.toast(data.msg);
				}
			},
			error: function(xhr, type, errorThrown) {
				mui.toast('指数获取失败，请稍后再试');
			}
		});
		
	}

	list = function() {
		return {
			upList: function(_type) {
				if(vm.tabUp == 1) {
					vm.list = [];
				}
				if(_type) {
					getData();
				}
				//实际不需要这个接口，没有上拉业务
				this.result.items = [];
				this.result.items.forEach(function(item) {
					vm.list.push(item);
				});

				if(vm.tabUp == 1) {
					vm.tabUp = 0;
					if(this.result.items.length > 6) {
						vm.$nextTick(function() {
							scrollSearch();
						});
					}
				}
				vm.wa && vm.wa.close();
				return closeList(_type, this.result.items.length);
			},
			resetList: function() {
				vm.myData.skipCount = 0;
			},
			err: function(xhe, type, thr) {
				vm.wa && vm.wa.close();
			}
		}
	}()
	var getData = function() {
		getImg();
		getHot();
		exponent();
		getAnnounce();
	}
	var db = new DB('xhguide',1024);
	db.execute("create table if not exists guide(isguide varchar(255))");
	
	/*
	 * 长监听
	 * */
	var setDate = function () {
    	var currDate = +new Date; 	
    	if (vm.nextStartDate && vm.nextStartDate < currDate) {
    		vm.nextStartDate = null;
    		getHot();
    	}  	
    	setTimeout(setDate,1000);
    }
	mui.plusReady(function() {
		getAnnounce()
		setDate();		
		window. addEventListener("show-index",function(e){ 
			var viewAll = plus.webview.all();
			viewAll.forEach(function (item) {
			  	if ( item.id != plus.runtime.appid && item.id != "HBuilder" && item.id!= _APPID_ && item.mType !='main') {
			  		plus.webview.close(item, 'none', 0);
			  	}
			});
		});
		db.fetch('select * from guide',function(ret){
			var ary = ret || [];
			if (ary.length>0) {
				//有值，说明已经显示过了，无需显示；
				//关闭splash页面；
				setTimeout(function() {
					plus.navigator.closeSplashscreen();
					plus.navigator.setFullscreen(false);
				}, 3000);
			} else {
				db.insert("guide",{isguide:true},function(res) {
					console.log("设置为已显示状态");
				});
				//显示启动导航
				mui.openWindow({
					id: 'guide',
					url: 'guide.html',
					styles: {
						popGesture: "none"
					},
					show: {
						aniShow: 'none'
					},
					waiting: {
						autoShow: false
					}
				});
			}
			
		});
		setStatistic("index");
		main = plus.webview.currentWebview();
		main.pathName = '首页';
		getData();
		mui.later(function() {
			_init({
				style: 'circle',
				offset: '70px',
				contentnomore: '已经到底啦'
			});
		}, 100);
		journal.sume.call(4);
		if(mui.os.android) {
			vm.isIos = false;
			var pushManager = plus.android.importClass("com.igexin.sdk.PushManager");
			var context = plus.android.runtimeMainActivity();
			pushManager.getInstance().turnOnPush(context);
		} else {
			vm.isIos = true;
		}
		vm.ios5 = true;
		var scrollTop = 0;
		var doc = mui(".tab")[0];
		window.addEventListener("refreshList", function(e) {
			vm.list = [];
			vm.myData.skipCount = 0;
			_init({
				style: 'circle',
				offset: '70px',
				contentnomore: '已经到底啦'
			});
		});
		plus.webview.currentWebview().setStyle({
			softinputMode: "adjustResize"
		});
	});
})(window, mui)