(function($) {
	var vm = new Vue({
		el: '.mui-content',
		data: {
			tab:0,
			time: 0,
			isShowCode: false,	// 是否显示图片验证码
			getCode: HOST_URL+'Account/ValidCode',
			isCodeOk: false, // 验证码是否正确
			isValidNum:false,
			isCanSave:false,
			changPhone:false,
			param: {
				UserNameOrPhoneNumber: '',
				Password: '',
				ValidCode: '',
				Clientid: '',
//							isShowPhone: true,
				RememberMe:true,
				
			},
			paramOther: {
				PhoneNumber:'',
				SmsCode: '',
				RememberMe:true,
				ClientId: '',
			}
		},
		methods: {
			/**
			 * @description 登录 
			 */
			toggleLoginWay:function(index){//切换登录方式
				this.isCanSave=false;
				var slider = mui('#slider').slider();
				slider.gotoItem(index)
				this.tab=index;
				var inputList=document.querySelectorAll("input");
				for(var i= 0;i<inputList.length;i++){
					inputList[i].blur()
				}
				if(this.tab==0){
					this.checkInput(".one-box")
				}else{
					this.checkInput(".two-box")
				}
				
			},
			checkInput:function(selector){
				this.isCanSave=false;
    			var inputList=mui(selector+" input");
    			for(var i=0;i<inputList.length;i++){
    				if(inputList[i].value==''||inputList[i].value==null||this.trim(inputList[i].value) == ''){//判断每个表单是否有值
    					this.isCanSave=false;
    					return;
    				}
    			}
    			if(this.tab==0){
					this.isCanSave=true;
				}else if(this.tab==1){
					this.isValidNum=true;
					if(this.isValidNum){
    					this.isCanSave=true;
    				}
				}

    		},
    		getValidNum:function(){//获取验证码
    			var phoneNumber=this.paramOther.PhoneNumber;
    			if (this.time > 0) {return;}
    			if (!phoneNumber) {
    				mui.toast("请输入手机号！");
    				return;
    			} else if (!/^\d{11}$/.test(this.trim(phoneNumber))) {
					mui.toast("手机号格式错误！");
					return;
				}
    			getCodeSms();
    			
    		},
			
			login: function (ev) {
				var _this = this;
				ev.target.focus(); //按钮获取焦点关闭软键盘
				if(! _this.isCanSave){
					return;
				}else{
					if( _this.tab==0){//账号登录
						$(ev.target).button('loading');		
						_this.$refs.phone.setAttribute('disabled', false);
						_this.$refs.password.setAttribute('disabled',false);
						http.post2(HOST_URL+"account/Authenticate_V124", _this.param,function(data, status, xhr) {
							console.log("账号登录结果token："+data.result.result) 
							console.log("账号登录结果："+JSON.stringify(data)) 
							if (data.result.loginSuccess) {
								var state = getState();
								state.token = data.result.result;
								state.userName = _this.param.UserNameOrPhoneNumber;
								setState(state);
								$.toast("登录成功");
								var curr = plus.webview.currentWebview();
								if (curr.opener().id!=plus.runtime.appid && curr.opener().id!="side.html") {
									$.fire(curr.opener(),"loginRefresh",{login: true});
								}
								$.fire(plus.webview.getWebviewById("/side.html"),"loginRefresh",{login: true});
								$.fire(plus.webview.getWebviewById("/templates/user/user-news-list-frame.html"),"sendNews",{});

								// 如果是资源详情 则刷新内容
                                mui.fire(plus.webview.currentWebview().opener(), 'reloadResourceDetail');
								mui.later(function(){
									curr.parent().evalJS('mui.back()');
								},100);
							} else {
								$.toast(data.result.rmsg);									
								if (_this.isShowCode) {
									_this.getCodeFn();
								}
								_this.isShowCodeFn();
							}
							_this.$refs.phone.removeAttribute('disabled');
							_this.$refs.password.removeAttribute('disabled');
							$(ev.target).button('reset');
						}, function(xhr, type, thr) {
							_this.$refs.password.removeAttribute('disabled');
							_this.$refs.phone.removeAttribute('disabled');		
							$(ev.target).button('reset');				
//							$.toast(xhr.responseText);
							error_code_handle(xhr, type, thr)
						});
					}else if(this.tab==1){//验证码登录
						if(_this.paramOther.PhoneNumber==""){
							$.toast('手机号不能为空');
							return;
						}
						if(_this.paramOther.SmsCode==""){
							$.toast('验证码不能为空');
							return;
						}
						$(ev.target).button('loading');	
						http.post(HOST_URL+'account/AuthenticateByPhoneNumber',_this.paramOther,function(data){
							console.log("验证码登录结果:"+JSON.stringify(data))
							if (data.result.loginSuccess) {
								var state = getState();
								state.token = data.result.result;
								state.userName = _this.paramOther.PhoneNumber;
								setState(state);
								$.toast("登录成功");
								var curr = plus.webview.currentWebview();
								if (curr.opener().id!=plus.runtime.appid && curr.opener().id!="side.html") {
									$.fire(curr.opener(),"loginRefresh",{login: true});
								}
								$.fire(plus.webview.getWebviewById("/side.html"),"loginRefresh",{login: true});
								$.fire(plus.webview.getWebviewById("/templates/user/user-news-list-frame.html"),"sendNews",{});
								// 如果是资源详情 则刷新内容
                                mui.fire(plus.webview.currentWebview().opener(), 'reloadResourceDetail');
                                if(vm.changPhone){
                                	changePage('../../index.html', '',{});
                                }else{
                                	mui.later(function(){
										curr.parent().evalJS('mui.back()');
									},100);
                                }
								
								$(ev.target).button('reset');	
							} else {
								$.toast(data.result.rmsg);	
								$(ev.target).button('reset');	
								
								
							}
						},function(xhr, type, thr) {
							_this.$refs.password.removeAttribute('disabled');
							_this.$refs.phone.removeAttribute('disabled');		
							$(ev.target).button('reset');				
//							$.toast(xhr.responseText);
							
							error_code_handle(xhr, type, thr)
						})
					}
				}
    			
				
			},
			/**
			 * @description 是否显示图片验证码
			 */
			isShowCodeFn: function () {
				this.checkInput('.one-box');
				http.post(HOST_URL+"Account/IsNeedCaptcha", {userName:this.param.UserNameOrPhoneNumber}, function(data) {
					vm.isShowCode = data.result.isNeedCaptcha;
				});
			},
			/**
			 * @description 重新获取验证码 
			 */
			getCodeFn: function () {
				console.log('1')
				this.getCode =  HOST_URL+"Account/ValidCode?Random=" + Math.random();
			},
			/**
			 * @description 去除前后空格 
			 * @param {String} str 目标字符串
			 */
			trim: function (str) {
				return str.replace(/(^\s*)|(\s*$)/g, "");
			},
//						loginWX:function(){
//							var wx=new Wx();
//							wx.authLogin('weixin');
//						},
		}
	});  
	
	mui.plusReady(function () {
//					 plus.oauth.getServices(function(services) {
//			            auths = services;
//			        }, function(e) {
//			            alert("获取登录服务列表失败：" + e.message + " - " + e.code);
//			        });
		var slider = mui('#slider').slider();
	    slider.stopped = true; //关闭滑动切换
		setStatistic("login");
		vm.param.Clientid = plus.push.getClientInfo().clientid;
		vm.changPhone = plus.webview.currentWebview().changPhone;
	})
	$(".UserNameOrPhoneNumber").on("tap",'.mui-icon-clear',function(){//点击清空登录账号
          	vm.param.UserNameOrPhoneNumber="";
         });
        $(".password .mui-icon-clear").on("tap",'.mui-icon-clear',function(){//点击清空密码
          	vm.param.Password="";
           })
     $(".UserNameOrPhoneNumber1").on("tap",".mui-icon-clear",function(e) {
			vm.paramOther.PhoneNumber="";
		});   
	 $(".valid-num").on("tap",".mui-icon-clear",function(e) {
			vm.paramOther.SmsCode="";
		});  	
        if(this.isShowCode){//点击清空验证码
         	$(".validCode").on("tap",'.mui-icon-clear',function(){
	          	vm.param.ValidCode="";
	        })
        }
	var setTime = function (time) {
		vm.time = parseInt(time) - 1;
		if ( vm.time == 0) {return;} else {
			mui.later(function(){
				setTime(vm.time);  
			},1000);
		}
	}
    	
	var getCodeSms = function () {
		console.log('ValidCode::'+vm.param.ValidCode)
		if(vm.param.ValidCode == '') {
				$.toast('请输入图形验证码');
//				_this.isState.phoneNumber = 1;
				return;
			}
//		http.post(BASE_appUser+"/GetLoginSmsCode",{
		http.post2(HOST_URL + 'Account/LoginVailCodeForPhone  ', {
			phoneNumber: vm.paramOther.PhoneNumber,
			code :vm.param.ValidCode
		},function (data) {
			console.log("获取验证码："+JSON.stringify(data));
			if(data.success){
				vm.isValidNum=true;				
				setTime(60);
			}else{
				$.toast(data.error.message);
			}
			
		},function (xhr,type,thr) {
			plus.nativeUI.toast("获取验证码失败",{verticalAlign:"center"});
		},true);
	}
})(mui);
   
   
    

    


    
    