(function ($) {
    var vm = new Vue({
        el: ".mui-content",
        data: {
            taby: false,
            tab: -1,
            tabType: false,
            isIos: false
        },
        methods: {
        	toggle: function (bool) {
        		this.taby = bool;
        		this.$nextTick(function(){
        			toggle(bool);
        		});
        	},
        	up: function (tab,p) {
        		if (!this.tabType) {return;}
        		this.tab = tab;
        		$.fire(plus.webview.currentWebview().children()[0],"tabList",{tab: tab});
        		if (this.taby) {this.toggle(false)}
        	}
        }
    });
    
    var toggle = function (bool) {
    	var childrenView = plus.webview.currentWebview().children()[0];
    	var hh = Number($("#header")[0].offsetHeight);
    	var top = 0,mask = "none";
    	if (bool) { 
			top = Number($(".tab-y")[0].offsetHeight)+ hh + 1;
			mask = "rgba(0,0,0,0.4)";
		}else {
			top = Number($(".tab-x")[0].offsetHeight)+ hh + 1;
		}
		console.log(top)
		childrenView.setStyle({
			bottom: "0px",
			top: (top) + "px",
			action: "show",
			mask: mask
		});
		
		childrenView.addEventListener("maskClick",function(){
			vm.toggle(false);
		},false);
    }
    
    var mySwiper = new Swiper('.swiper-container',{
		loop: false,
		effect: 'slide',
		slidesPerView: 5,
		speed: 500,  
		touchRatio : 0.5
	});
	
    $.plusReady(function () {
    	if(mui.os.ios){			
			vm.isIos = true
		}else{			
			vm.isIos = false
		}
    	var curr = plus.webview.currentWebview();
    	vm.tab = curr.tab;
    	if (!curr.sTo) {curr.sTo=0;}
    	mySwiper.slideTo(Number(curr.sTo), 1000, false); 
    	window.addEventListener("setTabType",function (e) {
    		vm.tabType = true;
    	}); 
    });
})(mui)