(function($){
	Vue.filter("toPrice",function (item) {
		 var reg = /^[0-9]+.?[0-9]*$/;
		  if (!reg.test(item)) {
		    return item.toFixed(2);
		  }
		return "￥"+item.toFixed(2);
		
	});
	Vue.filter("toTypeName",function (item) {
		var str = '';
		switch (item){
			case 0:
				str = "竞价";
				break;
			case 1:
				str = "竞拍";
				break;
			case 2:
				str = "定向";
				break;
			case 3:
				str = "商城";
				break;
			case 5:
				str = "竞价";
				break;
			default:
				break;
		}
		return str;
		
	});
	
	
    vm = new Vue({
        el:".mui-content",
        data: {
        	wa: null,
        	tabType: false,
            list: [], 
            isShow:false,
            isIos:false,
            myData: {
                resourceOrderState: -1,
                filterText: "",
				skipCount: 0,
				maxResultCount: 10
            },
            listType: {
                url:BASE_appOrder+"/QueryOrderList",      //请求地址
                page: "skipCount",    //分页参数名
                limit: "maxResultCount",   //返回条数参数名
                acc: 10       //每次增加几页
            }
        },
        methods: {
        	onenPage: function (type,val,state) {
        		switch (type){
        			case 'info':
        				var showTime = false,showPass = false;
        				if (state==1) {showTime=true} else if (state==2) {showPass = true}
            			changePage('order-info.html','订单详情',{oId:val.id, showTime: showTime, showPass: showPass});
        				break;
        			case 'trade':
        				pullfreshPage('/templates/order/order-trade-frame.html', '/templates/order/order-trade.html', '提货详情',{
        					contractId:val.id, 
        					bottom: 49,
        				});
        				break;
        			case 'see':
            			changePage('see-order.html','提货单',{oId:val.id});
        				break;
        			case 'pay':
        				console.log("订单详情"+JSON.stringify(val));
            			changePage('/templates/prod/confirm-pay.html','子项详情',{
        					list: val.resourceItemList || [],
        					mySumPrice: val.settlementAmount,
        					resourceDetail:val,
        					order: true
        				}); 
        				break;
        			default:
        				break;
        		}
        	}
        }
    });
    
    list = function () {
        return {
            upList: function (_type) {
            	switch(vm.resourceOrderState){
            		case -1:
            		setStatistic("orderAll");
            		break;
            		case 0:
            		setStatistic("orderPay");
            		break;
            		case 1:
            		setStatistic("orderPaied");
            		break;
            		case 7:
            		setStatistic("orderReceipted");
            		break;
            		case 2:
            		setStatistic("orderPickUp");
            		break;
            		case 6:
            		setStatistic("orderSettleAccounts");
            		break;
            		case 5:
            		setStatistic("orderCancle");
            		break;
            		case 4:
            		setStatistic("orderCompelete");
            		break;
            		case 9:
            		setStatistic("orderPickingUp");
            		break;
            		case 17:
            		setStatistic("orderConfirm");
            		break;
            	}
                if (vm.tabType) {
                	vm.list = [];
                	if($.os.ios) {
						mui.later(function(){
							mui('#pullrefresh').pullRefresh().scrollTo(0,0,100);
						},100)
					} else {
						mui.scrollTo(0, 100);
					}
                }               
                this.result.items.forEach(function (item) {
                    vm.list.push(item);
                });
                if(vm.list.length == 0){
                	vm.isShow = false
                }else{
                	vm.isShow = true
                }
                console.log("订单list:"+JSON.stringify(vm.list))
                vm.wa&& vm.wa.close();
                vm.tabType = false;
                mui.fire(plus.webview.currentWebview().parent(),'setTabType',{isTab: true});
                return closeList(_type, this.result.items.length);
            },
            resetList: function () {
            	mui.fire(plus.webview.currentWebview().parent(),'setTabType',{isTab: false});
                vm.myData.skipCount = 0;
            },
            err: function (xhr,type,thr) {
            	vm.wa&& vm.wa.close();
            	mui.fire(plus.webview.currentWebview().parent(),'setTabType',{isTab: true});
            }
        }
    }()
    
    
    $.plusReady(function (){
    	if(mui.os.ios){			
			vm.isIos = true
		}else{			
			vm.isIos = false
		}
    	vm.myData.resourceOrderState = plus.webview.currentWebview().tab;
       _init();
       
       window.addEventListener("tabList",function (e) {
       		$('#pullrefresh').pullRefresh().refresh(true);
       		vm.myData.resourceOrderState = e.detail.tab;
       		vm.tabType = true;
       		vm.myData.skipCount = 0;
       		vm.wa = plus.nativeUI.showWaiting("", {back: "none"});
			if($.os.ios) {
				mui('#pullrefresh').pullRefresh().scrollTo(0,0,100);
			} else {
				mui.scrollTo(0, 100);
			}
			_init();
       });
       
       window.addEventListener("updateData",function (e) {
       		console.log("订单列表刷新");
       		vm.tabType = true;
       		vm.myData.skipCount = 0;
       		_init();
       });
    });
    
})(mui)