			(function($) {
				Vue.filter("money",function(num){ 
			        var num = num.toFixed(2); 
			        return num;
			    });
				var vm = new Vue({
					el: ".mui-content",
					data: {
						activeTab: 1, //记录选中账号
						id: "",
						urlList: {
							listUrl: BASE_appOrder + '/GetMultipleInfoForApp', //列表
						},
						list: {},
						totalMountNot: 0, //未确认数量
						totalPriceNot: 0, //未确认价格
						totalCount: 0, //确认的总数
						isChooseAll: false,
						notNoData: false, //未确认没有数据
						noData: false, //确认没有数据
					},
					methods: {
						chooseTab: function(type) { //切换选择框
							this.activeTab = type;
							if(this.activeTab == 2) {
								$.fire(plus.webview.currentWebview().parent(), 'chooseTab', {
									tab: this.activeTab,
									flag: this.list.confirmMultipleList.length == 0 ? false : true,
//									totalCount: accounting.formatNumber(this.totalCount)
									totalCount: this.totalCount
								});
							} else {
								this.computedTotal();
								$.fire(plus.webview.currentWebview().parent(), 'chooseTab', {
									tab: this.activeTab,
									flag: this.list.notConfirmMultipleList.length == 0 ? false : true,
//									totalCount: accounting.formatNumber(this.totalCount)
									totalCount: this.totalCount
								});
							}
						},
						getData: function() {
							var self = this;
							self.notNoData = false;
							self.noData = false;
							http.post(self.urlList.listUrl, {
								id: self.id
							}, function(res) {
								if(res.success == true) {
									var temp = res.result;
									temp.totalCount = 0;
									if(temp.notConfirmMultipleList.length > 0) {
										for(var i = 0; i < temp.notConfirmMultipleList.length; i++) {
											temp.notConfirmMultipleList[i].flag = false; //增加展开flag
											temp.notConfirmMultipleList[i].choose = false;
										}
									} else {
										self.notNoData = true;
									}
									if(temp.confirmMultipleList.length > 0) {
										for(var j = 0; j < temp.confirmMultipleList.length; j++) {
											temp.confirmMultipleList[j].flag = false; //增加展开flag
											temp.totalCount += temp.confirmMultipleList[j].multipleQuantity;
										}
									} else {
										self.noData = true;
									}
									self.list = temp;
									console.log(JSON.stringify(self.list)); 
									self.totalCount = self.list.totalCount;
									$.fire(plus.webview.currentWebview().parent(), 'showFooter', {
										tab: 1,
										isShowRecieptOfGoodsButton: self.list.isShowRecieptOfGoodsButton,
										flags: self.list.notConfirmMultipleList.length == 0 ? false : true,
										totalPriceNot: 0.00,
										totalMountNot: 0.00,
										notNoData: !self.notNoData,
										isChooseAll:false
									});
								}
							}, true, '正在加载')
						},
						chooseItem: function(item) { //选中与取消
							item.choose = !item.choose;
							this.computedTotal();
						},
						toggleVis: function(item) { //展开与隐藏
							item.flag = !item.flag
						},
						computedTotal: function() {
							vm.totalPriceNot = 0;
							vm.totalMountNot = 0;
							var flag = false; //是不是全选了
							vm.list.notConfirmMultipleList.forEach(function(v) {
								if(v.choose) {
									vm.totalPriceNot += v.multipleMoney;
									vm.totalMountNot += v.multipleQuantity;
								} else {
									flag = true;
								}
							});
							if(flag) {
								vm.isChooseAll = false;
							} else {
								vm.isChooseAll = true;
							}
							console.log('isChooseAll' + vm.isChooseAll)
							$.fire(plus.webview.currentWebview().parent(), 'showFooter', {
//								totalPriceNot: accounting.formatNumber(accounting.toFixed(vm.totalPriceNot, 2)),
								totalPriceNot: vm.totalPriceNot, 
//								totalMountNot: accounting.formatNumber(accounting.toFixed(vm.totalMountNot, 2)),
								totalMountNot: vm.totalMountNot,
								tab: 1,
								isChooseAll: vm.isChooseAll
							});
						}

					}
				});
				document.addEventListener('chooseAll', function(e) { //全选
					vm.totalPriceNot = 0.00;
					vm.totalMountNot = 0.00;
					var choose = e.detail.choose;
					if(choose) {
						vm.list.notConfirmMultipleList.forEach(function(v) {
							v.choose = true;
							vm.totalPriceNot += v.multipleMoney;
							vm.totalMountNot += v.multipleQuantity;
						});
						$.fire(plus.webview.currentWebview().parent(), 'showFooter', {
//							totalPriceNot: accounting.formatNumber(accounting.toFixed(vm.totalPriceNot, 2)),
							totalPriceNot: vm.totalPriceNot,
//							totalMountNot: accounting.formatNumber(accounting.toFixed(vm.totalMountNot, 2)),
							totalMountNot: vm.totalMountNot,
							tab: 1,
							isChooseAll:choose
						});
					} else {
						vm.list.notConfirmMultipleList.forEach(function(v) {
							v.choose = false;

						});
					}
				});
				document.addEventListener('getGoodsDetails', function() { //弹框返回监听
					console.log("进入监听")
					vm.list = {};
					vm.getData();
				})
				document.addEventListener('showAlert', function() { //确认收货
					var notConfirmId = [];
					for(var m = 0; m < vm.list.notConfirmMultipleList.length; m++) {
						if(vm.list.notConfirmMultipleList[m].choose) {
							notConfirmId.push(vm.list.notConfirmMultipleList[m].multipleId);
						}
					}
					if(notConfirmId.length == 0) {
						$.toast('当前没有选中任何选项');
						return false;
					}
					if(!vm.list.isHavePayCode) { //没有设置交易密码
						var arr = [];
						arr.push('<p class="alert-info">您还未设置交易密码，请设置交易密码后再确认收货！</p>')
						showConfirm(arr.join(' '), function(e) {
							if(e) {
								changePage('/templates/edit/edit-tran-pass.html', '交易密码', {
									state: 3,
									phone: vm.list.phoneNumber,
									dire: "goods"
								});
							}
						});
					} else { //输入交易密码提货
						changePage('./order-trade-alert.html', "弹框", false, false, {
							_eff_: "slide-in-bottom",
							phone: vm.list.phoneNumber,
							contractId: vm.id,
							notConfirmId: notConfirmId
						});
					}

				})

				$.plusReady(function() {
					vm.id = plus.webview.currentWebview().contractId;
					vm.getData();
				});
			})(mui)