var $ = mui;
Vue.filter("toPrice",function (item) {
	 var reg = /^[0-9]+.?[0-9]*$/;
	  if (!reg.test(item)) {
	    return item;
	  }else if (item.toString().indexOf('.') != -1) {
	  		if (item.toString().split(".")[1].length>2) {
	  			item = Number(item).toFixed(2);
	  		}
	  }
	
	return "￥"+item;
	
});
var vm = new Vue({
	el: "#app",
	data: {
		isIos:false,
		isShow:false,
		listChange:[],
		disposal:'',//选择模式
		disposalOld:'',
		disposalNum:0, //模式id
		disposalNumOld:0,  
		hsum: 300, 
		list: [],
		cashDeposit: null,
		pId: null,
		isSplit:false,
		isFirstBidMultipleResource:false,
		isContinueOffer:false,
		isBiddingNotPayDeposit:false,
		resourceDetail: {
			resourcesType: -1 // 资源类型  1-竞拍
		}, // 资源详情
		currMaxSumPrice: 0, // 应该报最低的总价
		currentSumStartPrice: 0, // 总的起拍价
		nRange: 0, // 加价幅度的系数
		mySumPrice: 0, // 当前的总报价
		differencePrice:0 ,//差价
		myPriceTotal:0,//子项总计和
		num:0
	},
	watch: {
		'nRange': function(val) {
			this.setRecommandPrice();
		}
	},
	methods: {
		changeSwitch:function(){//提示信息
			vm.isShow = !vm.isShow;
		},
		changeSelect:function(item,ind){
			vm.num = 0;
			item.isSelect =! item.isSelect;	           			
   			for (var i = 0 ; i<vm.listChange.length ; i++) {
   				if(vm.listChange[i].isSelect){
   					vm.num ++
   				}	           				
   			};
   			if(vm.num > 1){
   				for (var i = 0 ; i<vm.listChange.length ; i++) {
       				vm.listChange[i].isSelect = false
   				}
   				vm.listChange[ind].isSelect = true
   			};
   			console.log(item.isSelect)
   			
			if(item.isSelect){
				vm.disposal = vm.listChange[ind].text;
				vm.disposalNum = vm.listChange[ind].value;
			}else{
				vm.disposal ='';
				vm.disposalNum = '';
			}
			console.log('处置方式:'+vm.disposal)
			console.log('处置方式id:'+vm.disposalNum)
			if(vm.disposalNum == 2){
				vm.list.forEach(function(item) {
					item.myPrice = 0
				});
				vm.mySumPrice = 0;
			}
		},
		getDisposal: function () { //选择处置模式
			var userPicker = new mui.PopPicker();													
			userPicker.setData(vm.listChange); 
			userPicker.show(function(items) {
				vm.disposal = items[0].text;
				vm.disposalNum = items[0].value; 
				if(vm.disposalNum == 2){
					vm.list.forEach(function(item) {
						item.myPrice = 0
					});
					vm.mySumPrice = 0;
				}
				console.log('处置方式:'+vm.disposal) 
				console.log('处置方式id:'+vm.disposalNum)
			});
		},
		// 设置推荐报价
		setRecommandPrice: function() {
			var currMaxSumPrice = vm.currMaxSumPrice + vm.resourceDetail.everBidIncrement * vm.nRange; // 当前应该报的价格
			var currentSumStartPrice = vm.currentSumStartPrice; // 当前的最高总价
            vm.myPriceTota= 0
			$.each(vm.list, function(index, item) {
				var currentPrice = item.startPrice || item.basePrice;
				// 算出真实价格
				var realPrice = currMaxSumPrice * (currentPrice * item.number / currentSumStartPrice) / item.number;
				// 保留两位并进位
				item.myPrice = Math.ceil(realPrice.toFixed(3) * 100) / 100;
				//差价
				vm.myPriceTotal += (item.myPrice * item.number)
				console.log('myPriceTotal:'+vm.myPriceTotal)
				
			});
			vm.differencePrice = 0;
			if(vm.disposalNum == 1){//危废--付费--加 
				vm.differencePrice = Number(vm.resourceDetail.currentPrice) + Number(vm.resourceDetail.everBidIncrement) - Number(vm.myPriceTotal)//总差价	
				console.log('计算后differencePrice：'+vm.differencePrice)
			}else if(vm.disposalNum == 3){//危废--收费--减
				vm.differencePrice = Number(vm.myPriceTotal) + Number(vm.resourceDetail.everBidIncrement) - Number(vm.resourceDetail.currentPrice)//总差价	
				console.log('计算后differencePrice：'+vm.differencePrice)
			}
			if(vm.differencePrice < 0){
				vm.differencePrice = 0
			}
			this.setTotalPrice();
			this.$forceUpdate();
		},
		// 设置当前的总报价
		setTotalPrice: function() {
			var _this = this;
			this.$nextTick(function() {
				setTimeout(function() {
					var mySumPrice = 0;
					_this.list.forEach(function(item) {
						mySumPrice += (item.myPrice * item.number);
					});
					_this.mySumPrice = mySumPrice;
					//console.log('mySumPrice222:'+_this.mySumPrice)
					if(vm.disposalNum == 1){//危废--付费--加
						vm.differencePrice = Number(vm.resourceDetail.currentPrice) + Number(vm.resourceDetail.everBidIncrement) - Number(_this.mySumPrice)//总差价	
						console.log('计算后differencePrice：'+vm.differencePrice)
					}else if(vm.disposalNum == 3){//危废--收费--减
						vm.differencePrice = Number(_this.mySumPrice) + Number(vm.resourceDetail.everBidIncrement) - Number(vm.resourceDetail.currentPrice)//总差价	
						console.log('计算后differencePrice：'+vm.differencePrice)
					}
					if(vm.differencePrice < 0){
						vm.differencePrice = 0
					}
	 			}, 200);
			});
		},
		// 提交报价
		submitPrice: function() {
			plus.key.hideSoftKeybord();

//						公共逻辑
//			             1、免费模式，报价=0
//			             2、非免费模式，单价可以=0，总价需>0
//						当上一次报价存在时
//			             1、如果上一次报价与本次报价选择模式不同，无需与上次比较大小
//			             2、如果上一次报价与本次报价选择模式相同
//			              A、当上次报价模式=免费时，本次不能选择免费，只能选择我要付费
//			              B、当上次报价模式=我要收费时，本次报价需<=上次报价-幅度                  
//			              C、当上次报价模式=我要付费时，
//                            a、当isIgnoreRangeWhenCharge=true，本次报价需>=上次报价
//                            b、当isIgnoreRangeWhenCharge=false，本次报价需>=上次报价+幅度
			if(vm.disposalNum == 0){
				mui.toast('请选择处置模式');
				return;
			}
			if(vm.disposal == ''){
				mui.toast('请选择处置模式');
				return;
			}
			if(vm.disposal == 3 && vm.disposalOld == 3 && (vm.resourceDetail.currentPrice - vm.resourceDetail.everBidIncrement) <= 0){
				mui.toast('请重新选择处置模式');
				return;
			}
			if(vm.disposal == 2 && vm.disposalOld == 2){
				mui.toast('请重新选择处置模式');
				return;
			}
			//判断是否是正数
			for(var i = 0; i < vm.list.length; i++) {
				var item = vm.list[i];		
				console.log(item.myPrice)

				if(item.myPrice < 0) {
					$.toast("报价必须是正数！");
					return;
				}
				if(item.myPrice === '' && item.myPrice !== 0) {
					$.toast("单价不能为空！");
					return;
				}

			}
			if(vm.disposalNum == 2){//（多次或者单次）免费模式，报价必须未零
				if(vm.mySumPrice != 0){
					mui.toast("免费模式报价只能为零");
					return;
				}
			}
			if(vm.resourceDetail.resourcesType == 0){//单次竞价资源
				if(vm.disposalNum != 2){
					if(vm.mySumPrice == 0){
						mui.toast("总报价必须大于零");
						return;
					}
				}
				
			}
			if(vm.resourceDetail.resourcesType == 5){//多次竞价资源
				if(vm.disposalNumOld != vm.disposalNum){//选择模式与上一个不一样（不需要和上次报价比较）
					if(vm.disposalNum == 2){//（多次或者单次）免费模式，报价必须==0
						if(vm.mySumPrice != 0){
							mui.toast("免费模式报价只能为零");
							return;
						}
					}else{
						if(vm.mySumPrice == 0){
							mui.toast("总报价必须大于零");
							return;
						}
					}
				}else{//选择模式与上一个一样（需要和上次报价比较）
					if(vm.disposalNum == 3){//收费模式(本次报价需<=上次报价-幅度)
						if(vm.mySumPrice == 0){
							mui.toast("总报价必须大于零");
							return;
						}
						if(vm.mySumPrice > (vm.resourceDetail.currentPrice - vm.resourceDetail.everBidIncrement)){
							mui.toast("不满足报价条件！");
							return;
						}
					}else if(vm.disposalNum == 1){//付费模式
						if(vm.mySumPrice == 0){
							mui.toast("总报价必须大于零");
							return;
						}
						if( vm.disposalNumOld == vm.disposalNum && vm.resourceDetail.isIgnoreRangeWhenCharge){//当isIgnoreRangeWhenCharge=true，本次报价需>上次报价
							if(vm.mySumPrice < vm.resourceDetail.currentPrice){
								mui.toast("不满足报价条件！");
								return;
							}
						}else{//当 =false，本次报价需>=上次报价+幅度
							if(vm.mySumPrice < (vm.resourceDetail.currentPrice + vm.resourceDetail.everBidIncrement)){
								mui.toast("不满足报价条件！");
								return;
							}								
						}
					}
				}
			}						
			
			vm.mySumPrice = this.getTofixed(vm.mySumPrice);// 报价金额只显示2位小数
			if(vm.isSplit){
				var str = "<div style='color: #181818;font-size:14px;font-weight:800;margin-bottom: 10px;'>提示</div><div class='tips'><p>此资源为拆标资源，最终价格以订单显示为准。 请注意，报价提交之后无法修改！</p><div><p class='tip-p'>当前报价:<span class='color-red'>"+vm.mySumPrice+"</span></p></div></div>";
			}else{
				var str = "<div style='color: #181818;font-size:14px;font-weight:800;margin-bottom: 10px;'>提示</div><div class='tips'><p>请确认报价,提交之后无法修改哟！</p><div><p class='tip-p'>当前报价:<span class='color-red'>"+vm.mySumPrice+"</span></p></div></div>";
			}
			if (vm.cashDeposit && vm.cashDeposit > 0 && !vm.isContinueOffer && !vm.isSplit) {
				var str = "<div style='color: #181818;font-size:14px;font-weight:800;margin-bottom: 10px;'>提示</div><div class='tips'><p>请确认报价,提交之后无法修改哟！</p><div><p class='tip-p'>当前报价:<span class='color-red'>"+vm.mySumPrice+"</span></p><p class='tip-p'>需冻结保证金:<span class='color-red'>"+vm.cashDeposit+"</span></p></div></div>";
			}else if(vm.cashDeposit && vm.cashDeposit > 0 && !vm.isContinueOffer && vm.isSplit){
				var str = "<div style='color: #181818;font-size:14px;font-weight:800;margin-bottom: 10px;'>提示</div><div class='tips'><p>此资源为拆标资源，最终价格以订单显示为准。 请注意，报价提交之后无法修改！</p><div><p class='tip-p'>当前报价:<span class='color-red'>"+vm.mySumPrice+"</span></p><p class='tip-p'>需冻结保证金:<span class='color-red'>"+vm.cashDeposit+"</span></p></div></div>";
			}
			showConfirm(str,['修改报价','确认报价'],function(res){
				if(res){
					plus.key.hideSoftKeybord();
					 
					return submitFn();
				}
				return;
			});
		},
		getTofixed: function(val) {
			if (val.toString().indexOf('.') != -1) {
		  		if (val.toString().split(".")[1].length>2) {
		  			return Number(val).toFixed(2);
		  		}
		  	}
			return val;
		},
		// 清空内容 如果是为0
		removeIfZero: function(val) {
			val.myPrice = val.myPrice.replace(/[^\d.]/g, "");  //清除“数字”和“.”以外的字符   
			val.myPrice = val.myPrice.replace(/\.{2,}/g, "."); //只保留第一个. 清除多余的   
			val.myPrice =val.myPrice.replace(".", "$#$").replace(/\./g, "").replace("$#$", ".");
			val.myPrice = val.myPrice.replace(/^(\-)*(\d+)\.(\d\d).*$/, '$1$2.$3');//只能输入两个小数   
			if (val.myPrice.indexOf(".") < 0 && val.myPrice != "") {//以上已经过滤，此处控制的是如果没有小数点，首位不能为类似于 01、02的金额  
		        val.myPrice = parseFloat(val.myPrice);
		    }
			val.myPrice = this.getTofixed(val.myPrice);
			if(val.myPrice < 0) {
				val.myPrice = "";
			}
			if(this.getTofixed(val.myPrice) > 100000000.00) {
				mui.toast('当前报价金额总计不可大于100000000.00元')
				val.myPrice = "";
			}
		}
	},
});

	var submitFn = function () {
		// 如果不是第一次 则直接请求
		if(!vm.isFirstBidMultipleResource || vm.isBiddingNotPayDeposit ) {
			var biddingItemInfo = [];
			for(var i = 0; i < vm.list.length; i++) {
				var item = vm.list[i]; 
				biddingItemInfo.push({
					itemId: item.id,
					officePrice: item.myPrice
				});
			}
			
			officePriceFn(biddingItemInfo);
			
		} else {
			// 如果第一次报价 则跳转
			changePage("./confirm-pay-waste.html", "冻结保证金", {
				mySumPrice: vm.mySumPrice,
				resourceDetail: vm.resourceDetail,
				list: vm.list,
				cashDeposit: vm.cashDeposit,
				disposalNum:vm.disposalNum
			});
		
		}
	}

	mui.init({
		swipeBack: false
	});
	var officePriceFn = function (biddingItemInfo) {
		// 请求报价接口
		http.post2(BASE_appBidding + "/OfficePricebyWH", {
			resourceId: vm.resourceDetail.id,
			officePrice: vm.mySumPrice, 
			biddingItemInfo: biddingItemInfo,
			disposalMode:vm.disposalNum
		}, function(data) {
			console.log('报价成功:'+JSON.stringify(data))
			if(data.result) {
				$.toast("报价成功!");
				mui.fire(plus.webview.currentWebview().opener(), 'reloadResourceDetail');
				mui.fire(plus.webview.currentWebview().opener(), 'updateList'); // 我的报价页面
				mui.fire(plus.webview.getWebviewById('/side.html'),'reloadNum',{});
				setTimeout(function() {
					mui.back();
				}, 300);
			} else {
				$.toast("报价失败!");
			}
		}, function(xhr,type,thr) {
			error_code_handle(xhr,type,thr);
		});
	}
	// 获取资源信息 
	function getResourceInfo(pId, pType) {
		http.post2(BASE_homeBiddingDetailService + "/GetBiddingInfo", {
			id: pId
		}, function(data) {
			console.log('获取资源信息'+JSON.stringify(data));
			vm.resourceDetail = data.result;
			vm.listChange = data.result.disposalModeList;
			vm.listChange.map(function(item){
				item['value'] = item['id'];
				item['text'] = item['name'];	
				if(item.isSelect && vm.resourceDetail.currentPrice > -1){
					vm.disposalNum = item.id;//1 == 付费 ，2 == 免费 ， 3 == 收费
					vm.disposalNumOld = item.id;//上次选择模式ID
					console.log('disposalNumOld:'+vm.disposalNumOld)
					vm.disposal = item.name;
					vm.disposalOld = item.name;
					if(item.id == 1){
						vm.listChange = vm.listChange; 
					}else if(item.id == 2){
						vm.listChange.splice(1,1);
					}else if(item.id == 3){
						if(item.id == 3 && (vm.resourceDetail.currentPrice - vm.resourceDetail.everBidIncrement) <= 0){
							vm.listChange.splice(2,1);
						}
						vm.listChange = vm.listChange;
					}												
				}
				if(item.isSelect && vm.resourceDetail.currentPrice == -1){
					vm.disposal = item.name;
					vm.disposalNum = item.id;
				} 
			});					
			console.log('获取资源信息222'+JSON.stringify(data));
			vm.resourceDetail.id = pId;
			if(vm.resourceDetail.currentPrice == -1){
				vm.resourceDetail.currentPrice = 0;
				vm.isFirstBidMultipleResource = true;
			}else{
				vm.isFirstBidMultipleResource = false;
			}
			vm.currMaxSumPrice = vm.resourceDetail.everBidIncrement;
			vm.list = data.result.resourceItems.map(function(item) {
				vm.currMaxSumPrice += parseFloat(item.currentPrice || item.startPrice || item.basePrice) * item.number;
				vm.currentSumStartPrice += (item.startPrice || item.basePrice) * item.number; // 总的起拍价
				if(item.myPrice == -1) {
					item.myPrice = 0
				} 
				vm.myPriceTotal += (item.myPrice * item.number);//差价
				return $.extend(item, { 
					price: 0, 
					totalPrice: 0,
					myPrice: !vm.isFirstBidMultipleResource ? item.myPrice : 0, // 我的报价
				});
				
			});
            vm.differencePrice = Number(vm.resourceDetail.currentPrice) + Number(vm.resourceDetail.everBidIncrement) - Number(vm.myPriceTotal)//总差价
			// 计算总价
			vm.setTotalPrice();
			initSlidebar() 
		}, function(xhr,type,thr) {
			error_code_handle(xhr,type,thr); 
		});
	}
	
	// 初始化推荐报价的滚动条
	function initSlidebar() { 
		vm.$nextTick(function() {
			if($("#hk-val").length < 1) return;
			$("#hk-val")[0].addEventListener('input', function() {
				//if (!$("input:focus")[0]) {
				//	$("input")[0].focus();
				//}
				var val = Number(this.value);
				var bf = Number(val / vm.hsum * 100);

				vm.nRange = val / 50;

				//$("input:focus")[0].value = val;
				this.style.backgroundSize = bf + "% 100%";

				$.each($(".hk-value i"), function(index, item) {
					if(bf < item.getAttribute("types")) {
						item.classList.remove("type1");
						item.classList.add("type2");
					} else {
						item.classList.remove("type2");
						item.classList.add("type1");
					}
				});
			});
		});
	}
	$.plusReady(function() {
		if(mui.os.ios){
			vm.isIos = true
		}else{ 
			vm.isIos = false
		};
		setStatistic("continueQuote",{});
		var curr = plus.webview.currentWebview();
		vm.pId = curr.pId;
		vm.isSplit = curr.isSplit;
		vm.cashDeposit = curr.cashDeposit;
		vm.isContinueOffer = curr.isContinueOffer;
		vm.isBiddingNotPayDeposit = curr.isBiddingNotPayDeposit;
		console.log('isContinueOffer:'+curr.isContinueOffer);
		console.log('isBiddingNotPayDeposit:'+curr.isBiddingNotPayDeposit);
		console.log('id:'+vm.pId);
		getResourceInfo(vm.pId);
	
	
	
	});