(function(mui) {
	mui.init({
		 gestureConfig:{
		   doubletap: false, //默认为false
		   longtap: false, //默认为false
		   isOutsideSeller:null,
		   companyType: '', // 公司身份类型
		  }
	});
	var dateReg = new RegExp("-", "g");
	
	Vue.filter("toTime", function(str) {
		var val = '';
		if (!str) {return val;}
		val = str.replace(dateReg, "/");
		return new Date(val).pattern("HH:mm:ss"); 
	});
	Vue.filter("toDateMD", function(str) {
		var val = '';
		if (!str) {return val;}
		val = str.replace(dateReg, "/");
		return new Date(val).pattern("MM-dd");  
	});
	Vue.filter("toPhone", function(str) {
		var phone = str;
		if(!getState().token && phone) {
			return phone.slice(0, 3) + "****" + phone.slice(-3);
		}
		return phone;
	});
	Vue.filter("toUserName", function(str) {
		var val = str;
		return val.substr(0, 2) + "****" + val.substr(-2);
	});
	Vue.filter("toPrice", function(item) {
		var reg = /^[0-9]+.?[0-9]*$/;
		if(!reg.test(item)) {
			return item;
		} else if(item.toString().indexOf('.') != -1) {
			if(item.toString().split(".")[1].length > 2) {
				item = Number(item).toFixed(2);
			}
		}

		return '￥' + item;
	});
	Vue.filter("times",function(num){ 
        var num = num.split('T')[0]; 
        return num;
    });
	var vm = new Vue({
		el: '.mui-content',
		data: {
			loadingList: true,
			imgsetw: 0,
			topBtn: false,
			login: false,
			share: false,
			popup: false,
			popupType: 4,
			pId: null,
			pType: null,
			infoView: true,
			isIndividual:false,
		   	isEnterprise:false,
		   	isIdentity:false,
		   	isWaste:false,
		   	isIos:false,
			dates: {
				step: 3,
				d: null,
				h: null,
				m: null,
				s: null
			},
			time: null,
			res: {}, // 资源信息
			showIsBidding: false,  //是否有人中标
			isShowOfferPriceBtn: false, // 是否显示报价按钮
			cerficationImg: '../../images/membersPower/icon_cx@2x.png', // 长协图标
			registerImg: '../../images/membersPower/icon_zc@2x.png', // 注册图标
			verifiedImg: '../../images/membersPower/img_rz@2x.png', // 已认证图标
			result:{},//判定
			companyName:'',
			tab:1
		},
		methods: {
			callTop: function() {
				callTop();
			},
			swiperNest:function(){			
				mySwiper.slideNext();
			},
			callPhone: function() {
				if(getState().token) {
					plus.device.dial(this.res.operatePhoneNumber, true);
				} else {
					if (vm.res.supplyAndDemandType==1) {
						setStatistic("getContactSup");
					}else {
						setStatistic("getContactDem");
					}
					pullfreshPage('../user/login-frame.html', '../user/login.html', '登录');
				}
			},
			buy: function(id, cashDeposit) {
				getInfoOne(function(){
					// 竞拍并且以出价
				if(!vm.res.isOffer && vm.res.resourcesType == 0) return;

				if(vm.dates.step != 2) {
					mui.toast("竞卖还未开始，请耐心等待")
					return;
				}
				if(vm.res.isSelfResource) {
					mui.toast("不能报价自己发布的资源哦!");
					return;
				}
				if(getState().token) {
						if(vm.res.isAllowNotCompanyBuy && vm.result.userAuthenticationType!=0 || vm.result.userAuthenticationType ==3){
							//去報價
							setStatistic("recommendprice");
							if(vm.res.isHazardousWaste && !vm.res.hazardousWasteError){
								changePage("prod-buy-waste.html", "报价", {
									pId: vm.pId,
									cashDeposit: cashDeposit,
									list: vm.res.resourceItemDtos,
									resourceDetail: vm.res,
									isSplit: vm.res.isSplit,
									isContinueOffer :vm.res.isContinueOffer,
									isBiddingNotPayDeposit :vm.res.isBiddingNotPayDeposit
								});
							}else if (vm.res.isHazardousWaste && vm.res.hazardousWasteError){
								vm.isWaste = true
							}else if(!vm.res.isHazardousWaste){
								changePage("prod-buy.html", "报价", {
									pId: vm.pId,
									cashDeposit: cashDeposit,
									list: vm.res.resourceItemDtos,
									resourceDetail: vm.res,
									isSplit: vm.res.isSplit
								});
							}
							
						}else{
					   		if(vm.result.userAuthenticationType==2){
						        //弹窗：看看别的资源
						        vm.isIndividual = true
						    }
						    if(vm.result.userAuthenticationType==1){
						        //弹窗：认证升级企业用户
						        vm.isEnterprise = true
						    }					    
						}
						if(vm.result.userAuthenticationType==0){
							if(vm.result.auditType==1){
						        //审核中
								//您的认证信息尚在审核中，请耐心等待
								mui.toast('您的认证信息尚在审核中，请耐心等待')
					   		}
					    	if(vm.result.auditType==2){
					        	//审核失败
								//您的认证信息审核失败，请重新上传资料
								mui.toast('您的认证信息审核失败，请重新上传资料')
					    	}else if(vm.result.auditType==-1){
					        	//未认证	（新用户，根本就没有提交过认证信息）		跳认证入口
								vm.isIdentity = true
					    	}  
					   		
						}
						
//					}
					
				} else {
					pullfreshPage('../user/login-frame.html', '../user/login.html', '登录',{});
				}
				}); 
				
			},
			changeTrue:function(){//跳认证入口
				vm.isEnterprise = false; 
				vm.isIndividual = false;
				vm.isIdentity = false;
				vm.isWaste = false;
				changePage('/templates/user/idenfity/identify-authentication.html','身份认证',{upgrade:false})
			},
			changeTrueOne:function(){//跳升级入口
				vm.isEnterprise = false;
				vm.isIndividual = false;
				vm.isIdentity = false;
				vm.isWaste = false;
				changePage('/templates/user/idenfity/identify-authentication.html','身份认证',{upgrade:true})				
			},
			changeWaste:function(){//跳危废认证
				vm.isEnterprise = false;
				vm.isIndividual = false;
				vm.isIdentity = false;
				vm.isWaste = false;
				changePage('/templates/user/idenfity/identify-waste.html','危废认证',{companyName:vm.companyName})				
			},
			changeFalse:function(){
				vm.isEnterprise = false;
				vm.isIndividual = false;
				vm.isIdentity = false;
				vm.isWaste = false;
			},
			shareToggle: function() {
				this.share = !this.share;
			},
			popupToggle: function(index) {
				mui.later(function() {
					vm.popup = !vm.popup;
					if(index) {
						vm.popupType = index;
						btnStatistic(index);
					}
				}, 100)
			},
			shareTap: function(id, ex) {
				var uri = '';
				var str = "";
				if(this.res.thumbnailResourceAttaches) {
					uri = this.res.thumbnailResourceAttaches[0].url;
					str = this.res.resourceName;
				} else {
					uri = this.res.imgUrl;
					str = this.res.name;
				}

				var reg = new RegExp("h_500,w_500", "g"); //创建正则RegExp对象  
				var stringObj = uri;
				uri = stringObj.replace(reg, "h_100,w_100");
				
				console.log(uri)
				
                if(vm.pType != undefined ){
                	var urlLine = COMMON_URL+'/Bidding/BiddingDetail?menu=Bidding&resourceId=' + this.pId;
                }else{
                	var urlLine = COMMON_URL+'/HotSupplyAndOrder/SupplyAndOrderListDetails?menu=SupplyAndOrderList&id=' + this.pId;
                }
				console.log(uri);
				var sObj = {
					url: urlLine,
					title: plus.webview.currentWebview().pathName,
					img: uri,
					content: str
				}
				shareAction(sObj, id, ex);
				mui.later(function() {
					vm.shareToggle();
				}, 500);
			},
			// 会员服务
			membersPower: function() {
				console.log('公司身份类型:', vm.companyType)
				/* 如果已登陆跳转会员服务页面，未登录跳登录页面 */
				if (getState().token) {
					changePage('/templates/user/members-power.html', '会员服务', {
						bottom:44, 
						companyType: vm.companyType
					})
				} else {
					pullfreshPage('../user/login-frame.html', '../user/login.html', '登录');
				}
			},
			//文件下载
			downloadWord:function(val){
				var _url = val;
				downloadFile.downWgt(_url);
			}
		}
	}); 
 

	var isType = function() {
		if(vm.res.resourcesType == 1) { //竞拍
			return ["winBidFlowAcu", "bookSpecificationAcu", "auctionNoticeAcu", "warmTipAcu"];
		} else if(vm.res.resourcesType == 4) { //预售
			return ["winBidFlowPre", "bookSpecificationPre", "auctionNoticePre", "warmTipPre"];
		} else { //竞价
			return ["winBidFlowBid", "bookSpecificationBid", "auctionNoticeBid", "warmTipBid"];
		}
	}

	var btnStatistic = function(index) {
		var arr = isType();
		if(index == 1) {
			setStatistic(arr[0]);
		} else if(index == 2) {
			setStatistic(arr[1]);
		} else if(index == 3) {
			setStatistic(arr[2]);
		} else if(index == 5) {
			setStatistic(arr[3]);
		}
	}

	var setTime = function(currTime, starTime, endTime) {
		if(!currTime || !starTime || !endTime) {
			return;
		}
		var reg = new RegExp("-", "g"); //创建正则RegExp对象
		var currTime = currTime;
		var starTime = starTime.replace(reg, "/");
		var endTime = endTime.replace(reg, "/");

		var data = {
			nowdate: new Date(currTime).getTime(),
			startdate: new Date(starTime).pattern("yyyy/MM/dd HH:mm:ss"),
			enddate: new Date(endTime).pattern("yyyy/MM/dd HH:mm:ss"),
			setday: 0,
			init: false
		}
		console.log("data：" + JSON.stringify(data));
		if(vm.time) {
			window.clearInterval(vm.item);
		}
		vm.time = $.leftTime(data, function(d) {
			if(d.status) {
				//d.status 状态 
				//d.d 天
				//d.h 时
				//d.m 分
				//d.s 秒
				vm.dates.step = d.step;
				vm.dates.d = d.d;
				vm.dates.h = d.h;
				vm.dates.m = d.m;
				vm.dates.s = d.s;
			} else if(d.step == 1 || d.step == 2) {
				vm.dates.step = 3;
				var curr = plus.webview.currentWebview();
				vm.infoView = true;
				console.log('curr.pId:', curr.pId)
				getInfo(curr.pId, curr.pType);
			}
		});
	}

	var getInfo = function(pId, pType, userNotificationId, isIndividualPush) {
		vm.loadingList = true;
		var _url = "";
		if(pType != undefined) {
			_url = BASE_appResource + "/QueryResourceDetailById";
		} else {//供需
			_url = BASE_appSupplyandDemandService + "/GetSupplyAndDemandsDetailById";
		}
		http.post(_url, { 
			id: pId,
			userNotificationId: userNotificationId || "",
			isIndividualPush: isIndividualPush || false
		},10000, function(data) { 
			if(vm.time) {
				window.clearInterval(vm.time);
			} 
			console.log('资源详情data：'+JSON.stringify(data)) 
			vm.loadingList = false;
			if (!data.result) {
				plus.nativeUI.toast("加载失败,重新访问试试~",{verticalAlign:"center"});
				mui.back();
				return;
			}						
			vm.companyType = data.result.companyType; // 公司身份类型
			console.log('公司身份类型companyType:' +vm.companyType)
			vm.companyName = data.result.companyName; // 公司身份类型companyName
			console.log('公司名称companyName:' +vm.companyName) 
			vm.isOutsideSeller = data.result.isOutsideSeller
//			console.log("isOutsideSeller：" +vm.isOutsideSeller)
			vm.res = data.result; 
			console.log('resourceBidType：'+data.result.resourceBidType)
			console.log('isShowHWAuthenticationButton：'+data.result.isShowHWAuthenticationButton)
			console.log('myCurrentOfferPrice：'+data.result.myCurrentOfferPrice)
			console.log('currentPrice：'+data.result.currentPrice)
			if(data.result.offerrecordList){
				data.result.offerrecordList.forEach(function(item) { 
				if (item.isBidding) {
					vm.showIsBidding = true; 
				}
			});
			}
			  
			vm.isShowOfferPriceBtn = new Date(vm.res.bidEndTime) > new Date()
			vm.infoView = false;
			setTime(data.result.currenTime, data.result.bidstarttime, data.result.bidendtime);
			vm.$nextTick(function() {
				if(mui('.mui-slider') && data.result.resourceAttaches) {
					if(data.result.resourceAttaches.length < 2) {
						return;
					}
					var gallery = mui('.mui-slider');
					gallery.slider({
						interval: 3000
					});
				}
			});

		}, function(xhr, type, thr) {
			plus.nativeUI.toast("加载失败,重新访问试试~",{verticalAlign:"center"});
			vm.loadingList = false; 
			mui.back();
		});
	}
	
	var getInfoOne = function(callback){
		var ws = plus.nativeUI.showWaiting();
		http.post(BASE_appUser + "/GetUserAuthorizationInfo", {},function(data) {
			ws.close()
			console.log('权限:'+JSON.stringify(data))
			vm.result = data.result;
			console.log(JSON.stringify(vm.result))
			callback&&callback();
		}, function(xhr, type, thr) {
			ws.close()
			mui.toast("获取用户失败");
		});
	}
	mui('.mui-scroll-wrapper').scroll({
		indicators: true //是否显示滚动条
	});
	mui.plusReady(function() {
		if(getState().token){
			getInfoOne()
		}
		
		var curr = plus.webview.currentWebview();
		curr.setStyle({
			bounce: "none",
			background: "#f4f4f4"
		});
		vm.imgsetw = mui(".mui-content")[0].offsetWidth;
		vm.pId = curr.pId;
		vm.pType = curr.pType;  
		console.log("vm.pId:"+vm.pId) 
		console.log("vm.pType:"+vm.pType)
		getInfo(vm.pId, vm.pType, curr.userNotificationId || "",curr.isIndividualPush || false);

		if(getState().token) {
			vm.login = true;
		}

		window.addEventListener("loginRefresh", function(e) {
			vm.login = e.detail.login;
		});

		// 重新加载数据
		window.addEventListener("reloadResourceDetail", function() {
			vm.isShowOfferPriceBtn = false;
			console.log('curr.pId:'+ curr.pId)
			getInfo(curr.pId, curr.pType);
			getInfoOne()
		});

		mui(".mui-content").on("touchmove", ".article-mask", function(e) {
			e.preventDefault();
		}, false);
		
		var agent = navigator.userAgent.toLowerCase();
		var iLastTouch = null;
		if (agent.indexOf("iphone") >= 0 || agent.indexOf("ipad") >= 0) {
		    document.body.addEventListener("touchend", function (event) {
		        var a = new Date().getTime();
		        iLastTouch = iLastTouch || a + 1;
		        var c = a - iLastTouch;
		        if (c < 500 && c > 0) {
		            event.preventDefault();
		            return false;
		        }
		        iLastTouch = a
		    }, false);
		};
		
	});

})(mui)