	var shares = {}; 
	/*
	 * sObj : {url:地址,title:标题,img:图片url（需网络图片）,content:内容} 
	 * */
	var shareAction = function(sObj,id, ex) {
		var s = null;
		if ( arguments.length > 2 && typeof sObj == 'object' ) {if (!'title' in sObj || !'content' in sObj) {console.log('请设置title或者content');return;}} else {console.log('请设置分享内容');return;};
		if (!id || !(s = shares[id])) {console.log("无效的分享服务！");mui.toast("无效的分享服务！");return;};
		if (s.authenticated) {console.log("---已授权---");shareMessage(sObj,s, ex);} else {console.log("---未授权---");s.authorize(function() {shareMessage(sObj,s, ex);}, function(e) {console.log("认证授权失败：" + e.code + " - " + e.message);mui.toast("认证授权失败：" + e.code + " - " + e.message);});}
	};
	
	var shareMessage = function(sObj,s, ex) {
		var img = ('img' in sObj ? sObj['img'] : undefined) ;
		var thumb = "";
		var msg = {
			extra: {
				scene: ex
			}
		};
		if(undefined != img){
			thumb = img.split("/")[0] == "http:" ? img : (img.split("/")[0] == "https:"? img :"images/108x108.png");
		}else {
			thumb = "images/108x108.png";
		}
		if (sObj['url']) {msg.href = sObj['url'];}
		if(s.id == 'weixin'){
			msg.type = 'web';
		}
		msg.title = sObj['title'];
		if(s.id == 'weixin'){
			msg.type = 'web';
		}
		msg.content = sObj['content'];
		msg.thumbs = [thumb];
		console.log("分享参数："+JSON.stringify(sObj)) 
		s.send(msg, function() {
			plus.nativeUI.toast("分享到\"" + s.description + "\"成功！ ");
		}, function(e) { 
			if (e.code == -2) {
				plus.nativeUI.toast("用户取消分享");
			} else {
				plus.nativeUI.toast("分享到 " + s.description + " 失败! "+e.code);
			}
		});
	};
	
	var updateSerivces = function() {
		plus.share.getServices(function(s) {
			for (var i in s) {
				var t = s[i];
				shares[t.id] = t;
				//console.log("分享服务插件" + t.id)
			}
		}, function(e) {
			//console.log("获取分享服务列表失败：" + e.message);
		});
	};
	
	mui.plusReady(function () {
	    updateSerivces();
	});