function checkForUpdates(uri,appKey){
	plus.runtime.getProperty(plus.runtime.appid,function(v){    //获取当前app版本
        plus.storage.setItem("version",v.version);
        mui.getJSON( uri +'jplat-dcms-client/appVersion/getLast', {
			version: v.version,
			appKey: appKey
		}, function(data) {
			console.log("更新："+JSON.stringify(data));
			if (data.success) {
				if (data.data) {
					var vs1 = parseInt(data.data.appVersion.replace(/\./g,""));
					var vs2 = parseInt(v.version.replace(/\./g,""));
					if (vs1 > vs2) {
						plus.nativeUI.confirm(data.data.remark || "暂无日志", function(event) {
							if (0 == event.index) {
								downWgt( uri + data.data.url );
							}
						}, data.data.name, ["立　　即", "取　　消"]);
					}
				}
			}
		}); 
	})
}

var up_journal = function () {
	http.post(JOURNAL_URL+"/jplat-dcms-client/appDownLoadData/saveCount",{
		headers:{'Content-Type': 'application/json'},
		sysVersion: plus.os.name + plus.os.version,          //设备系统类型
		sysName: appCode,    				//app名称
		userName: getState().userName || '',			//用户名称
	},10000,function ( data ) {
		console.log("更新日志成功！");
	},function( xhr, type, hrow) {
		console.log("更新日志失败:"+xhr.status);
		error_code_handle(xhr, type, hrow);
	});
}

function downWgt(wgtUrl){  //下载资源包
	
	
	plus.nativeUI.showWaiting("正在下载文件...",{back: "none"});
		plus.downloader.createDownload( wgtUrl, {filename:"_doc/update/"}, function(d,status){
			if ( status == 200 ) { 
				up_journal();
			    installWgt(d.filename); // 安装wgt包
			} else {
			    plus.nativeUI.alert("下载包失败！");
			}
			    plus.nativeUI.closeWaiting();
		}).start();
	}
			
function installWgt(path){   //安装
	plus.nativeUI.showWaiting("正在安装...",{back: "none"});
	plus.runtime.install(path,{},function(){
		var state = getState();
		delete state.lauchFlag;
		setState(state);
		plus.nativeUI.closeWaiting();
		     plus.nativeUI.alert("完成！",function(){
		     plus.runtime.restart();
		});
	},function(e){
		plus.nativeUI.closeWaiting();
	     plus.nativeUI.alert("安装文件失败["+e.code+"]："+e.message);
	});
}