//(function(mui) {
	Vue.filter('phone', function(val) {
		var val = String(val)
		// 手机号隐藏中间四位
		var len = val.length
		if(len < 8) return
		return val.substr(0, 3) + '****' + val.substr(len - 4, len - 1)
	})
	Vue.filter("times",function(num){ 
        var num = num.split('T')[0]; 
        return num;
    });
	var vm = new Vue({
		el: '.mui-content',
		data: {
			datas: {
				auditTypes: 0,
				phoneNumber: 0,
			},
			wasteTab: false, // 是否展示危废认证
			wasteType: '', // 危废认证状态
			isAuthentication: false,
			isLoading: false,
			name:'',
			wasteTypeName:'',
			companyName:''//公司名称
		},
		created: function() {
			this.getInfo();
		},
		methods: {
			/**
			 * @description  获取个人信息
			 */
			getInfo: function() {
				var _this = this;
				http.post(BASE_appUser + '/GetUserInfo', function(data) {
					console.log('获取个人信息:'+JSON.stringify(data))
					_this.datas = data.result;
					
//					_this.wasteTab = data.result.isShowHazardousWasteTab; // 是否展示危废
					_this.wasteType = data.result.hazardousWasteAuditType; // 危废认证类型
//					_this.wasteTypeName = data.result.hazardousWasteAuditTypeName; // 危废认证类型汉化
					switch (_this.wasteType) {
						case -1:
							_this.wasteTypeName = '立即认证';
							break; 
						case  2:
							_this.wasteTypeName = '立即认证';
							break;
						case 1:
							_this.wasteTypeName = '审核中';
							break;
						case 3:
							_this.wasteTypeName = '审核通过';
							break;
						case 4:
							_this.wasteTypeName = '已过期，请重新认证';
							break;
						default:
							break;
					}
					// 如果显示未申请，或者0 的时候隐藏认证信息
					if(data.result.auditTypes != -1 && data.result.auditTypes != 0) {
						_this.isAuthentication = true;
					}
					_this.isLoading = true;
				}, function(xhr, type, thr) {
					_this.isLoading = true;						
					var result = JSON.parse(xhr.response);
					mui.toast(result.error.message)
				});
			},
			changpages:function(){//修改用户名
				console.log('获取个人信息:'+JSON.stringify(vm.datas))
				if(vm.datas.shouldSetUserName){
					pullfreshPage('editName-frame.html','editName.html','修改用户名', {});
				}else{
					mui.toast("你已修改过用户名")
					return false;
				}
			},
			changeP:function(){
				if(vm.datas.auditType == -1){//未认证
					changePage('/templates/user/idenfity/identify-authentication.html','身份认证')
				}else if (vm.datas.auditType == 2){//审核失败
						if(vm.datas.upgradeUserAuthenticationType == 1){//个人
							pullfreshPage('/templates/user/idenfity/identiy-person-frame.html','/templates/user/idenfity/identiy-person.html','个人认证', {direction:'personCenter',upgradeUserAuthenticationType:vm.datas.upgradeUserAuthenticationType,userAuthenticationType:vm.datas.userAuthenticationType});
						}else if (vm.datas.upgradeUserAuthenticationType == 2){//个体
							pullfreshPage('/templates/user/idenfity/identiy-individual-frame.html','/templates/user/idenfity/identiy-individual.html','个体认证', {direction:'personCenter',upgradeUserAuthenticationType:vm.datas.upgradeUserAuthenticationType,userAuthenticationType:vm.datas.userAuthenticationType});
						}else if (vm.datas.upgradeUserAuthenticationType == 3){//企业
							pullfreshPage('/templates/user/idenfity/identiy-company-frame.html','/templates/user/idenfity/identiy-company.html','企业认证', {direction:'personCenter',upgradeUserAuthenticationType:vm.datas.upgradeUserAuthenticationType,userAuthenticationType:vm.datas.userAuthenticationType});
						}
					}else if (vm.datas.auditType == 1){//审核中
						changePage('/templates/user/idenfity/identiy-look.html','身份认证',{upgrade:false})									
					}else if (vm.datas.auditType == 3){// 已认证 									
						if(vm.datas.userAuthenticationType == 1){//个人认证成功后，升级到个体或者企业 
							changePage('/templates/user/idenfity/identiy-look.html','身份认证',{upgrade:true})
						}else{
							changePage('/templates/user/idenfity/identiy-look.html','身份认证',{upgrade:false})
						}
					}
				
			},
			changLook:function(){//身份认证
				changePage('/templates/user/register/register-member.html','权限管理')
			},
//			-1未申请；1待审核；2审核未通过；3审核通过；4已过期
			changWaste:function(type){//危废认证
				if (type == -1 || type == 2 || type == 4) {
					// 认证或者编辑
					changePage('/templates/user/idenfity/identify-waste.html','危废认证', {
						type: type,
						companyName: vm.companyName
					})
				} else if(type == 1 || type == 3){
					// 认证详情
					changePage('/templates/user/idenfity/identiy-look-waste.html','危废认证',{
						companyName: vm.companyName
					})
				}
			},
			unbind:function(){//解除绑定
				http.post(BASE_appUser + '/UnbindWeChat', function(data) {
					console.log('解除绑定:'+JSON.stringify(data))
					if(data.success){
						mui.toast("解绑成功")
						vm.getInfo();
						mui.fire(plus.webview.currentWebview().opener(),'refreshUserinfo',{})
					}else{
						mui.toast("解绑失败")
					}
				}, function(xhr, type, thr) {
					
				});
			},
			bind_wx:function(){
				var wx=new Wx();
				wx.authLogin('weixin',10);
				vm.getInfo()
			},
			goPage:function(type){
				if(type) { //点击设置密码
					changePage("/templates/edit/edit-login-pass.html","登录密码",{state:2,phone:vm.datas.phoneNumber});
				}else if(!type){ // 修改密码
					changePage('/templates/edit/login-pass-state.html','登录密码');
				}
			},
			goPhone:function(){//点击修改手机号
				changePage("/templates/user/changePhone.html","修改手机号",{phone:vm.datas.phoneNumber});
			}
		}
	});
    window.addEventListener("upData", function(e) {
		vm.getInfo()
	})
    window.addEventListener("refresh", function(e) {
		vm.getInfo()
	})
	mui.plusReady(function() {
		vm.companyName = plus.webview.currentWebview().companyName
		window.addEventListener("refresh", function(e) {
			vm.datas.headImg = e.detail.userImg
			vm.getInfo();
		})
	});
//})(mui) 